/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _FILETRANSFERNODEIMPL_H_
#define _FILETRANSFERNODEIMPL_H_
#include "FileTransferNode.h"
#include <OSTAORB/OSTAORB.h>
#include "..\..\XMLRelay\XMLVDK010Lib\XMLFileTransferNode.h"
#include "..\..\XMLRelay\RelayMapLib\XMLRelayMap.h"
#include "ReposEnum.h"

#include <string>
#include <iostream>
#include <fstream>
using namespace std;

class FileTransferNodeImpl:public virtual POA_FileTransferNode,public PortableServer::RefCountServantBase
{
public:
    FileTransferNodeImpl(CORBAServer* corba);
    virtual ~FileTransferNodeImpl();

	CORBA::Boolean GetRootFile(const char* strReposHost, const char* strFile);
	CORBA::Boolean GetObjectCodeFile(const char* strReposHost, const char* strFile);
	CORBA::Boolean GetCollectorFile(const char* strReposHost, const char* strFile);
	CORBA::Boolean GetDataFile(const char* strReposHost, const char* strFile);

	CORBA::Boolean StoreResultsFile(const char* strReposHost, const char* strTest, const char* strTestRun, const char* strFileName);
	CORBA::Boolean OpenResultsFile(const char* strFileName);
	ByteSequence* ReadBytes();
	CORBA::Boolean CloseResultsFile();

private:
	void Connect();
	bool IsReposOnLAN(string strReposHost);
	string GetRemoteFileURL(string strReposHost, int nType, string strFile);
	bool TransferFileToLocal(string strURL, string strFile);

	bool ParseFTPURL(string strURL, string& strServer, int& nPort, string& strUser,
					string& strPass, string& strRemotePath);
    CORBAServer* m_corba;
    string  m_registered_name;
	XMLFileTransferNode_var m_RelayTransferNode;
	XMLRelayMap_var  m_RelayMap ;
	string	m_relayUnderscoreIP ;

	int m_nFileDesc;
	bool m_bFileOpen;
	int m_nSize;
};
#endif
