/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc CyrStRepository
///////////////////////////////////////////////////////////////////////////////

#ifndef _CyrStServer_i_h
#define _CyrStServer_i_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <Repository/CyrStRepository.h>
#include <Repository/CyrStProv.h>
#include <CyrffAPI/CECFFServer.h>

///////////////////////////////////////////////////////////////////////////////
// @class   CyrStServerImpl | This class is the implementation class for the
//          CORBA OpenSTARep server interface.  It wraps up the functionality
//          of the COM wrapper interface.
// @base    public | POA_CyrStServer
class CyrStServerImpl : public virtual POA_CyrStServer,public PortableServer::RefCountServantBase
{
    // @access Public Members
public:
    // @cmember Constructor
    CyrStServerImpl( CyrStProvider* pProvider, ParamList_ptr params );
    virtual ~CyrStServerImpl();         // @cmember Destructor

    char* GetProjects( long& count );   // @cmember Returns list of Projects within Server
    char* GetRegisteredName();          // @cmember Returns registered name of object

    // @access Protected Members
protected:
    CyrStProvider* m_provider;  // @cmember Reference to parent Provider
    string      m_regName;   // @cmember Registered name of object
    CECFFServer*  m_com;       // @cmember Pointer to COM wrapper
}
;

#endif

