/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include "CECSimpleParse.h"
CECSimpleParse::CECSimpleParse(const string& str)
        :m_string(str),
        m_startpos(0),
        m_separator_pos(0)
{
#ifndef _WIN32
	if (m_string[m_string.size() - 1] == '\r')
		m_string.erase(m_string.size() - 1) ;
#endif 
}


CECSimpleParse::~CECSimpleParse()
{}

string CECSimpleParse::getNext(char separator)
{
    string retstr("");
    if(m_separator_pos>=m_string.length())return "";
    m_startpos=m_string.find_first_of(separator,m_separator_pos);
    if(m_startpos==string::npos)return "";
    retstr = m_string.substr(m_separator_pos,m_startpos-m_separator_pos);
    m_separator_pos=++m_startpos;
    return retstr;
}

string CECSimpleParse::getNextToken(char separator)
{
    string retstr("");
    if(m_separator_pos>=m_string.length())return "";
    m_startpos=m_string.find_first_of(separator,m_separator_pos);
    if(m_startpos==string::npos)return "";
    retstr = m_string.substr(m_separator_pos,m_startpos-m_separator_pos);
	m_separator_pos=m_string.find_first_not_of(separator,m_startpos);
    return retstr;
}

string  CECSimpleParse::getToEnd()
{
    return m_string.substr(m_separator_pos);

}
