/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#ifndef __ONEXECUTERSTOP__
#define __ONEXECUTERSTOP__

#include <list>
using std::list;
#include <string>
using std::string;

enum EnumExecuterEvent
{
	EEE_ONSTOPTASKGROUP,
	EEE_ONSTOPEXECUTER,
	EEE_FINISHED,
	EEE_UNKNOWN
};

void onExecuterStop(InjectorControl_ptr pControl, const string & registeredName) ;

class CExecuterEvent
{
public:
	CExecuterEvent()
		:eExecuterEventType_(EEE_UNKNOWN), lTaskGroupId_(-1)
	{}
	CExecuterEvent(EnumExecuterEvent eExecuterEventType, long lTaskGroupId = -1)
		:eExecuterEventType_(eExecuterEventType), lTaskGroupId_(lTaskGroupId)
	{}

	EnumExecuterEvent	eExecuterEventType_ ;
	long				lTaskGroupId_ ;
};

typedef list<CExecuterEvent> executerEventList ;


#endif