/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _XMLRELAYMAPIMPL_H_
#define _XMLRELAYMAPIMPL_H_
#include "..\RelayMapLib\XMLRelayMap.h"
#include "ServerSettings.h"

#include <OSTAORB.h>
#include <string>
#include <fstream>
#include <map>
using namespace std;

class XMLRelayMapImpl:public virtual POA_XMLRelayMap,public PortableServer::RefCountServantBase
{
public:
    XMLRelayMapImpl(CORBAServer* corba, CServerSettings settings);
    virtual ~XMLRelayMapImpl();

	CORBA::Boolean GetRelayForAlias(const char* strAlias, RelayDef& def);
	void AddRelayForAlias(const RelayDef& def);
	void GetRelayList(RelayList& rList);
	void ping() {};

	CORBA::Boolean GetLocalRelayDef(RelayDef& def);

private:
	void LoadRelyMap();
    CORBAServer* m_corba;
    std::string  m_registered_name;

    typedef std::map<string,RelayDef> RelayMap;
	RelayMap m_relayMap;
	CServerSettings m_settings;
};
#endif
