/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _xmlvdk_h
#define _xmlvdk_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <OSTAORB.h>
#include "xmlrpc.h"

#ifdef _WIN32
#   ifdef BUILD_XMLVDK
#       define DECLSPEC_XMLVDK __declspec(dllexport)
#   else
#       define DECLSPEC_XMLVDK __declspec(dllimport)
#   endif

#define XMLVDK_EXP extern "C" DECLSPEC_XMLVDK int

///////////////////////////////////////////////////////////////////////////////
// The following functions must all be exported from any XMLVDK module.  If not it
// will not work correctly.
XMLVDK_EXP XMLVDKInit( CORBAServer* pServer, CCallManager* pCallManager, int nTraceLevel );
XMLVDK_EXP XMLVDKShutdown();
#else
extern "C"
{
#define XMLVDK_EXP int
int XMLVDKInit( CORBAServer* pServer, CCallManager* pCallManager, int nTraceLevel );
int XMLVDKShutdown();
}
#endif


#endif
