/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XML_IC_TaskGroupExecInfo.h: interface for the CXML_IC_TaskExecInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XML_IC_TASKGROUPEXECINFO_H__8EA82A00_B002_40E0_BE67_1E25801BA4AE__INCLUDED_)
#define AFX_XML_IC_TASKGROUPEXECINFO_H__8EA82A00_B002_40E0_BE67_1E25801BA4AE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xmlrpc.h"
#include "InjectorControl.h"

class CXML_IC_TaskGroupExecInfo : public CXMLParameter  
{
public:
	CXML_IC_TaskGroupExecInfo();
	CXML_IC_TaskGroupExecInfo(TaskGroupExecInfo tgInfo);
	virtual ~CXML_IC_TaskGroupExecInfo();
	string GetType();
	bool ToXML(string& strXML);
	bool FromXML(CXMLNodeElement* pNode);

	void SetValue(TaskGroupExecInfo tgInfo);
	const TaskGroupExecInfo & GetValue();
	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };

private:
	CCallManager* m_pCallManager;
	TaskGroupExecInfo m_tgInfo;
	BOOL m_bSet;
	string AddMember(string name, CXMLParameter* param);

};

#endif // !defined(AFX_XML_IC_TASKGROUPEXECINFO_H__8EA82A00_B002_40E0_BE67_1E25801BA4AE__INCLUDED_)
