/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XML_IS_HTTPTaskGroupSnap.h: interface for the CXML_IS_HTTPTaskGroupSnap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XML_IS_HTTPTASKGROUPSNAP_H__544FC312_84E3_4756_8542_843C9C01C7D4__INCLUDED_)
#define AFX_XML_IS_HTTPTASKGROUPSNAP_H__544FC312_84E3_4756_8542_843C9C01C7D4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "xmlrpc.h"
#include "InjectorStatus.h"
#include "HTTPInjectorStatus.h"

class CXML_IS_HTTPTaskGroupSnap : public CXMLParameter  
{
public:
	CXML_IS_HTTPTaskGroupSnap();
	CXML_IS_HTTPTaskGroupSnap(HTTP_TaskGroupSnap TGSnap);
	virtual ~CXML_IS_HTTPTaskGroupSnap();

	void SetValue(HTTP_TaskGroupSnap TGSnap);
	const HTTP_TaskGroupSnap & GetValue();

	bool ToXML(string& strXML);
	bool FromXML(CXMLNodeElement* pNode);

	string GetType();

	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };

private:
	CCallManager* m_pCallManager;
	string AddMember(string name, CXMLParameter* param);

	//variables
	HTTP_TaskGroupSnap m_HTTP_TaskGroupSnap;
	BOOL m_bSet;


};

#endif // !defined(AFX_XML_IS_HTTPTASKGROUPSNAP_H__544FC312_84E3_4756_8542_843C9C01C7D4__INCLUDED_)
