/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TimeServiceHandler.h: interface for the CTimeServiceHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTMANAGERHANDLER_H__DBA2FBE4_6962_46EF_933F_BFB76C8C4331__INCLUDED_)
#define AFX_TESTMANAGERHANDLER_H__DBA2FBE4_6962_46EF_933F_BFB76C8C4331__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xmlrpc.h"
#include "OSTAORB.h"
#include "TestManager.h"

#include <string>
using namespace std;

class CTestManagerHandler : public CCallHandler  
{
public:
	CTestManagerHandler(CORBAServer* pServer);
	virtual ~CTestManagerHandler();

	CXMLResponse* ProcessMethodCall(CXMLRequest* request);
	CXMLResponse* OnTaskGroupStopped(string strManagerReg, long lTaskGroupId, TaskGroupStopReason eReason);
	CXMLResponse* OnInjectorStopped(string strManagerReg, string strInjectorHost);
	CXMLResponse* GetTestVUs(string strManagerReg);
	CXMLResponse* GetTestTotalAndActiveVUs(string strManagerReg, long lActiveVUs, long lTotalVUs);

private:
	CORBAServer* m_pCorba;
};

#endif // !defined(AFX_TESTMANAGERHANDLER_H__DBA2FBE4_6962_46EF_933F_BFB76C8C4331__INCLUDED_)
