/* Copyright (C) 2000-2001 Quotium SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#ifndef _XMLFILETRANSFERNODEIMPL_H_
#define _XMLFILETRANSFERNODEIMPL_H_
#include "..\XMLVDK010Lib\XMLFileTransferNode.h"
#include <OSTAORB.h>
#include <string>
#include "..\RelayMapLib\XMLRelayMap.h"
#include "ReposEnum.h"

class XMLFileTransferNodeImpl:public virtual POA_XMLFileTransferNode,public PortableServer::RefCountServantBase
{
public:
    XMLFileTransferNodeImpl(CORBAServer* corba);
    virtual ~XMLFileTransferNodeImpl();

	bool TransferFileToLocal(const string & strURL, const string & strFile);
	CORBA::Boolean GetRemoteFileURL(const char* strReposHost, CORBA::Long nType, const char* strFile);


	bool ParseFTPURL(string strURL, string& strServer, int& nPort, string& strUser, string& strPass, string& strRemotePath);
	void Connect() ;
private:
	CORBAServer* m_corba;
    std::string  m_registered_name;
	XMLRelayMap_ptr m_RelayMap;
};

#endif