/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _XMLRelayTestRunImpl_H_
#define _XMLRelayTestRunImpl_H_
#include "..\XMLVDK010Lib\XMLRelayTestRun.h"
#include "..\RelayMapLib\XMLRelayMap.h"
#include "XMLParser.h"
#include "xmlrpc.h"
#include "mutex.hpp"
#include <OSTAORB.h>
#include <string>
#include <map>
using std::map;

typedef map<string, CXMLRequest *> XMLRequestMapType ;

class XMLRelayTestRunImpl:public virtual POA_XMLRelayTestRun,public PortableServer::RefCountServantBase
{
public:
    XMLRelayTestRunImpl(CORBAServer* corba);
    virtual ~XMLRelayTestRunImpl();

	virtual void AddTestOutput(const char* strReposHost, const char* strTestRunReg, const char* strType, const char* strMessage);
	void flush();
	void SetFlush(bool bFlush) { m_bFlush = bFlush ;}

private:
    CORBAServer*		m_corba;
    std::string			m_registered_name;
	XMLRelayMap_ptr		m_RelayMap;
	XMLRequestMapType	m_requestMap ;
	CTMutex				m_requestMapMutex ; 
	bool				m_bFlush ;
};
#endif
