/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _XMLRELAYVARFACTORYIMPL_H_
#define _XMLRELAYVARFACTORYIMPL_H_
#include "..\XMLVDK011Lib\XMLRelayVarFactory.h"
#include <OSTAORB.h>
#include <string>
#include "..\RelayMapLib\XMLRelayMap.h"


class XMLRelayVarFactoryImpl:public virtual POA_XMLRelayVarFactory,public PortableServer::RefCountServantBase
{
public:
    XMLRelayVarFactoryImpl(CORBAServer* corba);
    virtual ~XMLRelayVarFactoryImpl();
    virtual CORBA::Long RegisterScript(const char* strTargetMachine,const char* strScriptName); 
	virtual CORBA::Long DeregisterScript(const char* strTargetMachine,const char* strScriptName, CORBA::Boolean bKeepAlive);
	virtual CORBA::Boolean ClearAll(const char* strTargetMachine);

	virtual CORBA::Boolean CreateMutex(const char* strTargetMachine,const char* strName);
	virtual CORBA::Boolean CreateSimpleSemaphore(const char* strTargetMachine,const char* strName);
	virtual CORBA::Long GetVariable(const char* strTargetMachine, const char* strName, CORBA::Long size, const char* strFile, const char* strFileid,
					  const char* strDimensions, const char* strValues, CORBA::Long options, CORBA::Long seed, const char* strScriptname);
	
	virtual CORBA::Long TPMutex_lock(const char* strTargetMachine, const char* mutexName);
	virtual CORBA::Boolean TPMutex_unlock(const char* strTargetMachine, const char* mutexName, CORBA::Long mutexid);
	virtual CORBA::Long TPMutex_trylock(const char* strTargetMachine, const char* mutexName);

	virtual CORBA::Boolean SimpleSemaphore_acquire(const char* strTargetMachine, const char* semName);
	virtual CORBA::Boolean SimpleSemaphore_release(const char* strTargetMachine, const char* semName);
	virtual CORBA::Boolean SimpleSemaphore_tryacquire(const char* strTargetMachine, const char* semName);

	virtual char* GlobalVariable_get_value(const char* strTargetMachine, const char* strVarName, const char* strExpression, CORBA::Long lVarId);
	virtual CORBA::Long GlobalVariable_set_value(const char* strTargetMachine, const char* strVarName, const char* strNewval, const char* strExpression, CORBA::Long lVarId);
	virtual CORBA::Boolean GlobalVariable_next_value(const char* strTargetMachine, const char* strVarName, CORBA::Long lVarId);
	virtual CORBA::Boolean GlobalVariable_generate_value(const char* strTargetMachine, const char* strVarName, CORBA::Long lVarId);
	virtual CORBA::Boolean GlobalVariable_reset_seed(const char* strTargetMachine, const char* strVarName, CORBA::Long lVarId);

	virtual CORBA::Boolean DoesSimpleSemaphoreExist(const char* strTargetMachine, const char* strVarName);
	virtual CORBA::Boolean DoesMutexExist(const char* strTargetMachine, const char* strVarName);

private:
    CORBAServer* m_corba;
    std::string  m_registered_name;
	XMLRelayMap_ptr m_RelayMap;

};
#endif
