/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CallManager.cpp: implementation of the CCallManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CallManager.h"

CCallManager* g_pCallManager = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCallManager::CCallManager()
{
	g_pCallManager = this;
}

CCallManager::~CCallManager()
{

}

void CCallManager::AddHandler(string strName, CCallHandler* handler)
{
	HANDLER_MAP hMap;
	hMap.strName = strName;
	hMap.pHandler = handler;

	m_arrHandlers.Add(hMap);
}

void CCallManager::AddDataProvider(CCustomDataProvider* provider)
{
	m_arrProviders.Add(provider);
}

CCallHandler* CCallManager::GetHandlerForName(string strName)
{
	for (int i = 0; i<m_arrHandlers.GetSize(); i++)
	{
		HANDLER_MAP hMap = m_arrHandlers.GetAt(i);
		if (hMap.strName == strName)
		{
			return hMap.pHandler;
		}
	}
	return NULL;
}

CCustomDataProvider* CCallManager::GetProviderForType(string strType)
{
	for (int i = 0; i<m_arrProviders.GetSize(); i++)
	{
		if (m_arrProviders.GetAt(i)->GetType() == strType)
		{
			return m_arrProviders.GetAt(i);
		}
	}
	return NULL;
}

void CCallManager::LoadServerSettings(string strSettingsFile)
{
	m_settings.ReadSettings(strSettingsFile);
}
