/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// FileTransfer.cpp: implementation of the CFileTransfer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FileTransfer.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFTPFileTransfer::CFTPFileTransfer()
{
	m_pFtpConn = NULL;
}

CFTPFileTransfer::~CFTPFileTransfer()
{

}

bool CFTPFileTransfer::OpenConnection(string strAddress,
								   int nPort, string strUser, string strPass)
{
	m_pFtpConn = m_session.GetFtpConnection(strAddress.c_str(), strUser.c_str(), strPass.c_str(), nPort, false);
	if(m_pFtpConn)
			return true;

	return false;
}

bool CFTPFileTransfer::SendFile(string strLocalPath, string strRemotePath)
{
	// Remove any earlier versions of the file before sending the new version
	m_pFtpConn->Remove(strRemotePath.c_str());
	return m_pFtpConn->PutFile(strLocalPath.c_str(), strRemotePath.c_str()) != FALSE;
}

bool CFTPFileTransfer::GetFile(string strRemotePath, string strLocalPath)
{
	// Get the remote file, overwriting any existing local copy
	return m_pFtpConn->GetFile(strRemotePath.c_str(), strLocalPath.c_str(), FALSE) != FALSE;
}
