/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLBase64.cpp: implementation of the CXMLBase64 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XMLBase64.h"
#include "Base64Coder.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLBase64::CXMLBase64()
{
	m_bSet = false;
}

CXMLBase64::CXMLBase64(const string & strValue)
{
	SetValue(strValue);
}

CXMLBase64::~CXMLBase64()
{
}

bool CXMLBase64::ToXML(string& strXML)
{
	if (!m_bSet)
		return false;

	Base64Coder Coder;
	Coder.Encode(m_strVal.c_str());

	strXML += "<value><base64>"+string(Coder.EncodedMessage())+"</base64></value>";
	return true;
}

bool CXMLBase64::FromXML(CXMLNodeElement* pNode)
{
/* Kyle Harrison 11/8/01 : Modified to use new CXMLParser Wrapper Class */ 

	string strEncoded = pNode->GetText();
	Base64Coder Coder;
	Coder.Decode(strEncoded.c_str());

	SetValue(Coder.DecodedMessage());

	return true;
}

void CXMLBase64::SetValue(const string & strValue)
{
	m_strVal = strValue;
	m_bSet = true;
}

const string & CXMLBase64::GetValue()
{
	return m_strVal;
}
