/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLBase64.h: interface for the CXMLBase64 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLBASE64_H__7D0F4306_BA10_4206_9744_6F6367D149DE__INCLUDED_)
#define AFX_XMLBASE64_H__7D0F4306_BA10_4206_9744_6F6367D149DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XMLParameter.h"

class CXMLBase64 : public CXMLParameter  
{
public:
	CXMLBase64();
	CXMLBase64(const string & strValue);
	virtual ~CXMLBase64();

	bool ToXML(string& strXML);
	bool FromXML(CXMLNodeElement* pNode);

	void SetValue(const string & strValue);
	const string & GetValue();

	string GetType() { return "base64"; };
	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };
private:
	string m_strVal;
	bool m_bSet;
	CCallManager* m_pCallManager;
};

#endif // !defined(AFX_XMLBASE64_H__7D0F4306_BA10_4206_9744_6F6367D149DE__INCLUDED_)
