/* Copyright (C) 2001 Kyle Harrison
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLParser.h: interface for the CXMLParser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLPARSER_H__0D11E3CB_25ED_4058_BF6D_4A44C84A4646__INCLUDED_)
#define AFX_XMLPARSER_H__0D11E3CB_25ED_4058_BF6D_4A44C84A4646__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
class CXMLNodeElement
{
public:
	CXMLNodeElement();
	virtual ~CXMLNodeElement();

public:
	void SetXMLNode(IXMLDOMNode *pXMLNode);

	CString GetNodeName();
	CString GetText();
	BOOL HasChildNodes();
	CXMLNodeElement* GetFirstChild();
	CXMLNodeElement* GetNextSibling();
	CXMLNodeElement* GetChildElementByName(CString strName);

private:
	IXMLDOMNode *m_pXMLNode;
	
};

class CXMLParser  
{
public:
	CXMLParser();
	virtual ~CXMLParser();

	BOOL Parse(CString strXML);
	CXMLNodeElement* GetRootElement();

	CString m_strXML;
	IXMLDOMDocument *m_pXMLDoc;
};

#endif // !defined(AFX_XMLPARSER_H__0D11E3CB_25ED_4058_BF6D_4A44C84A4646__INCLUDED_)
