/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLResponse.h: interface for the CXMLResponse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLRESPONSE_H__4A84DFCC_14A6_4579_92B3_8D1E866509EE__INCLUDED_)
#define AFX_XMLRESPONSE_H__4A84DFCC_14A6_4579_92B3_8D1E866509EE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XMLParser.h"
#include "XMLParameter.h"
#include <string>
using namespace std;

class CXMLResponse  
{
public:

	typedef enum {PARSE_FAILURE, UNRECOGNIZED_PARAM, INVALID_PARAM, INSUFFICIENT_PARAMS, TOO_MANY_PARAMS, FUNC_NOT_FOUND, UNKNOWN_ERROR} XML_ERROR;
	bool IsError() { return m_bError; };
	string ToXML();
	CXMLResponse(string strXMLResponse);
	CXMLResponse();
	virtual ~CXMLResponse();
	string m_strXMLResponse;
	CArray <CXMLParameter*,CXMLParameter*> m_params;
	void SetError(int errType) { m_errType = errType; m_bError = true; };
	string PrintError();
private:
	string ErrorToXML();
	bool m_bError;
	int m_errType;

};

#endif // !defined(AFX_XMLRESPONSE_H__4A84DFCC_14A6_4579_92B3_8D1E866509EE__INCLUDED_)
