#ifndef PSL__PSL_RTNDEF_LOADED
#define PSL__PSL_RTNDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: PSL_RTNDEF                  */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This module defines function prototypes for all the general      */
/*  PSL routines.                                */
/*                                       */
/*                                       */
/*===========================================================================*/


/*    Include STDDEF.H to ensure that SIZE_T is defined  */

#include    <stddef.h>

/*    Include STDIO.H to ensure that FILE is defined  */

#include    <stdio.h>

/*    Include SETJMP.H to ensure JMP_BUF is defined      */

#include    <setjmp.h>

/*    Include STDARG.H to ensure that VA_LIST is defined  */

#include    <stdarg.h>

/*    Include TYPES.H to ensure that UID_T is defined  */

#ifdef UNIX
#include <sys/types.h>
#endif

/*   Define Incomplete Structures for all referenced types */

#include <psl_structures.h>     /* Common Structures */

#ifdef VMS
struct  RAB;                /* RAB */
#endif

/*   Define SYSSHR routine names */

#include <sysshr_rtns.h>

/*
 *    Include the function prototypes for the PSL memory allocation routines
 *    her to prevent users having to add the header when the routines may be
 *    compiled out.
 */
#include <psl_alloc_rtndef.h>

#if 0
TODO alanw - unused
unsigned long   BIT_BEST_FIT (void *bitmask_ptr,
                              unsigned long *offset_ptr,
                              unsigned long *size_ptr,
                              unsigned long *count_ptr,
                              unsigned long *retoff_ptr);

unsigned long   BIT_CLEAR (void *bitmask_ptr,
                           unsigned long *offset_ptr,
                           unsigned long *count_ptr);

unsigned long   BIT_COUNT (void *bitmask_ptr,
                           unsigned long *offset_ptr,
                           unsigned long *size_ptr,
                           unsigned long *count_ptr);

unsigned long   BIT_FIRST_FIT (void *bitmask_ptr,
                               unsigned long *offset_ptr,
                               unsigned long *size_ptr,
                               unsigned long *count_ptr,
                               unsigned long *retoff_ptr);

unsigned long   BIT_SET (void *bitmask_ptr,
                         unsigned long *offset_ptr,
                         unsigned long *count_ptr);

void    BIT_STATS (void *bitmask_ptr,
                   unsigned long *size_ptr,
                   unsigned long *freebits_ptr,
                   unsigned long *freefrag_ptr,
                   unsigned long *maxfrag_ptr);

#ifdef  VMS
unsigned long   BIT_TEST (void *bitmask_ptr,
                          unsigned long *offset_ptr);
#endif  /* VMS */
#endif

void   CHK_DATANAME (const char *buf_ptr,
                     const long *buflen_ptr,
                     long *status_ptr);

void   CHK_LONG_DATANAME (const char *buf_ptr,
                          const long *buflen_ptr,
                          long *status_ptr);

#if 0
void   CHK_IDENT (const char *buf_ptr,
                  const short *buflen_ptr,
                  short *status_ptr);

void   CHK_PATTERN (const char *buf_ptr,
                    const short *buflen_ptr,
                    short *status_ptr);

void   CHK_PICTURE (const char *buf_ptr,
                    const short *buflen_ptr,
                    void (*actrtn_ptr)(),
                    unsigned char *type_ptr,
                    unsigned char *sign_ptr,
                    unsigned char *decimal_ptr,
                    unsigned short *idigits_ptr,
                    unsigned short *fdigits_ptr,
                    short *status_ptr);

void   CHK_SYSTELNAME (const char *buf_ptr,
                       const short *buflen_ptr,
                       short *status_ptr);
unsigned long   CHK_USERNAME (const char *username_ptr);
#endif

long   CONFIRM_RESPONSE (void);

#ifdef VMS
void   CVT_VMSDATE_TO_DATTIM (unsigned long *vms_dattim_ptr,
                              unsigned long *psl_date_ptr,
                              unsigned long *psl_time_ptr);

void   CVT_DATTIM_TO_VMSDATE (unsigned long *psl_date_ptr,
                              unsigned long *psl_time_ptr,
                              unsigned long *vms_dattim_ptr);
#endif /* VMS */
unsigned long   CYR_PRODUCT (void);

Boolean DPID_RUNNING(struct diagstk *diagp);

#ifdef VMS
void    GET_TERMINAL_DEVICE (struct dsc$descriptor_s *devdsc_ptr,
                             short *len_ptr);
#else
unsigned long   GET_TERMINAL_DEVICE (char *dev_ptr,
                                     short *len_ptr);
#endif
void   GET_OPENSTA_VERSION (char *vers_ptr);

void   INIT_DEBUG ();

#ifdef VAX
jmp_buf *JMP_ADDR(jmp_buf jmp_env);
#endif
/*
 *    Standard listing routines (O.S. versions)
 */
unsigned long   LIST_ALLOCATE (struct diagstk *diag_ptr,
                               struct list_ctx **context_ptr);

unsigned long   LIST_CLOSE (struct list_ctx *context_ptr);

void   LIST_DEALLOCATE (struct list_ctx *context_ptr);

unsigned long   LIST_EXPFIL (struct list_ctx *context_ptr,
                             char *expfil_ptr,
                             unsigned long expfil_size);

unsigned long   LIST_GET_DETAILS (struct   list_ctx *context_ptr,
                                  unsigned long     type,
                                  unsigned long     *value );

unsigned long LIST_INIT (struct list_ctx *context_ptr,
                         const  char     *utility_ptr,
                         const  char     *def_file_ptr,
                         const  char     *rel_file_ptr,
                         const  char     *subhdg1_ptr,
                         const  char     *subhdg2_ptr,
                         const  char     *version_ptr);

unsigned long   LIST_LINE (struct list_ctx *context_ptr,
                           const  char     *line_ptr);

unsigned long   LIST_LINE_COLUMN_ONE (struct list_ctx *context_ptr,
                                      const  char     *line_ptr);

unsigned long   LIST_LINE_REFERENCED (struct list_ctx *context_ptr,
                                      const  char *line_ptr);

#ifdef VMS
unsigned long   LIST_LOCKS (struct list_ctx *context_ptr,
                            unsigned long lockid,
                            unsigned long type_flag,
                            void (*outrtn_ptr)
                            (struct dsc$descriptor_s *strdsc_ptr));
#endif

unsigned long   LIST_NEWPAGE (struct list_ctx *context_ptr);

unsigned long   LIST_OUTPUT_ERROR_BUFFER (struct list_ctx *context_ptr,

        const char *errbuf,
        unsigned long numlin,
        unsigned long width);

unsigned long   LIST_PARSE (struct list_ctx *context_ptr);

unsigned long   LIST_SETUP (char *list_value_ptr,
                            Boolean spool_qual,
                            struct list_ctx *context_ptr);

unsigned long   LIST_SKIPLINES (struct   list_ctx *context_ptr,
                                unsigned long     no_of_lines);

unsigned long   LIST_SUBHEADING (struct list_ctx *context_ptr,
                                 const  char *subhdg3_ptr,
                                 const  char *subhdg4_ptr,
                                 const  char *subhdg5_ptr,
                                 const  char *subhdg6_ptr);

unsigned long   LIST_TESTPAGE (struct   list_ctx *context_ptr,
                               long     no_of_lines);

#ifdef VMS
unsigned long   LISTV30_OUTPUT_ERROR (struct dsc$descriptor_s *strdsc_ptr,
                                      struct list_ctx *context_ptr);
#endif

char  *PSLCHR_GETSTR (unsigned char trmtyp,
                      unsigned char chrset);

void  *PSLCHR_GETTBL (unsigned char tbltyp,
                      unsigned char trmtyp,
                      unsigned char chrset);
#ifndef VMS
void    PSL_ADDROOT (const char *string_ptr,
                     char *outbuf_ptr,
                     size_t outbuf_size);
#endif
#ifdef UNIX
void    PSL_ADDVARROOT (const char *string_ptr,
                        char *outbuf_ptr,
                        size_t outbuf_size);

void    PSL_ADDETCROOT (const char *string_ptr,
                        char *outbuf_ptr,
                        size_t outbuf_size);
#endif

unsigned long   PSL_ADD_DIAGNOSTIC (struct diagstk *diag_ptr,
                                    char *fmt_ptr, ...);

unsigned long   PSL_ADD_STATDIAG (struct diagstk *diag_ptr,
                                  char *msg_ptr);

struct diagstk *PSL_ALLOCATE_DIAGNOSTICS (void);

unsigned long   PSL_ASCBIN (unsigned char *numchr,
                            char *inpbuf,
                            unsigned char *radix,
                            void *number,
                            unsigned short *chrcnt);

unsigned long   PSL_BINASC (void *number,
                            unsigned char *numchr,
                            unsigned char *radix,
                            char *inpbuf,
                            unsigned short *flags);

void   PSL_CALC_CHK_DIG (char *string,
                         short *string_len,
                         char *chkdig);

void   PSL_CARDFILE_ADD (void *data_ptr,
                         char *text_ptr);

void   *PSL_CARDFILE_LOCATE (char *text_ptr);

void   PSL_CARDFILE_REMOVE (char *text_ptr);

void   PSL_CHANGE_USERNAME (char* pUsername ,long flag);

unsigned long   PSL_CHK_ERREXIT (void);

unsigned long   PSL_CHK_FILENAME (const char *filename_ptr);

unsigned long   PSL_CNV_STYP (char *prd_code_ptr,
                              char *prd_name_ptr);

unsigned long PSL_COMPRESS_DATE (unsigned long year,
                                 unsigned long month,
                                 unsigned long day,
                                 unsigned long *date_ptr);

unsigned long PSL_COMPRESS_TIME (unsigned long hours,
                                 unsigned long mins,
                                 unsigned long secs,
                                 unsigned long msecs,
                                 unsigned long *time_ptr);

#if 0
TODO alanw - unused
unsigned long   PSL_CREATE_PRDFILE (struct diagstk *diag_ptr,
                                    const char *prd_ptr,
                                    const char *version_ptr,
                                    const char *date_ptr,
                                    struct prd_data *prd_data_ptr);
unsigned long   PSL_CREATE_XTERM (struct diagstk *diag_ptr,
                                  char *cmd_ptr,
                                  char *title_ptr,
                                  char *iconname_ptr,
                                  unsigned long flags,
                                  long *pid_ptr,
                                  char *devnam_ptr,
                                  unsigned long devnam_len);
#endif

void   PSL_DEALLOCATE_DIAGNOSTICS (struct diagstk *diag_ptr);

#ifdef VMS
unsigned long   PSL_DIAG_ACTRTN (struct dsc$descriptor_s *msgdsc_ptr,
                                 struct diagstk *usrdiag_ptr);
#endif

unsigned long   PSL_DIAG_ERRNO(struct diagstk *diag_ptr, char *rtn_nam_ptr);


void   PSL_DIAG_INVERT (struct diagstk *diag_ptr);


#ifdef WIN32
unsigned long   PSL_DIAG_LASTERROR (struct diagstk *diag_ptr,
                                    const char *rtn_name_ptr);
void   PSL_LOG_LASTERROR (struct diagstk *diag_ptr,
                          unsigned long msgnum,
                          ...);
#endif /* WIN32 */


void   PSL_DIAG_OUTRTN (struct diagstk *diag_ptr);

void   PSL_DIAG_POSTRTN (struct diagstk *diag_ptr);

unsigned long   PSL_DISPLAY_IDENT (struct diagstk *diag_ptr,
                                   char prd);

unsigned long   PSL_DISPLAY_STATS (struct psl_dsdat *dsdat);

#ifdef VMS
unsigned  int   PSL_EXCEPT (void *sigarr,
                            void *mecharr);
#endif

void   PSL_EXIT (void);



unsigned long   PSL_EXPAND_DATE (unsigned long psl_date,
                                 unsigned long *year_ptr,
                                 unsigned long *month_ptr,
                                 unsigned long *day_ptr,
                                 unsigned long *weekday_ptr);

unsigned long   PSL_EXPAND_TIME (unsigned long psl_time,
                                 unsigned long *hours_ptr,
                                 unsigned long *mins_ptr,
                                 unsigned long *secs_ptr,
                                 unsigned long *msecs_ptr);



void   PSL_FAO (char *out_ptr,
                unsigned long outlen,
                char *inp_ptr, ...);

void   PSL_FAO_L (char *out_ptr,
                  unsigned long outlen,
                  char *inp_ptr,
                  va_list *va_ptr);

unsigned long   PSL_FILE_PARSE (const char *inp_file_ptr,
                                const char *def_file_ptr,
                                const char *rel_file_ptr,
                                const char *relexp_extn_ptr,
                                char *exp_file_ptr,
                                unsigned long max_exp_len,
                                unsigned long flags);

void   PSL_FIX_ERRORCTX (struct diagstk *usrdiag_ptr,
                         unsigned long context);

void   PSL_FLUSH_ERRORS (struct diagstk *diag_ptr,
                         unsigned long number);



unsigned long   PSL_FMT_DATTIM (unsigned long psl_date,
                                unsigned long psl_time,
                                char *date_buf,
                                unsigned long buflen,
                                unsigned long dattyp,
                                unsigned long flags);




void   PSL_FORMAT_DUMP (char *inpbuf_ptr,
                        unsigned short buflen,
                        unsigned long bufoff,
                        unsigned long bufadr,
                        char *outbuf_ptr,
                        unsigned short outlen,
                        unsigned long flags);

void   PSL_GET_DATTIM (unsigned long *date_ptr,
                       unsigned long *time_ptr);

unsigned long   PSL_GET_DDIR (char *ddir);

char  *PSL_GET_DIAGNOSTIC (struct diagstk *diag_ptr,
                           unsigned long *ctx_ptr);

unsigned long   PSL_GET_ERRORCTX (struct diagstk *diag_ptr);

void   PSL_GET_FDNAME (unsigned long file_dsc,
                       char *exp_file_ptr,
                       unsigned long max_exp_len);

void   PSL_GET_FILENAME (FILE *file_ptr,
                         char *exp_file_ptr,
                         unsigned long max_exp_len);

unsigned long   PSL_GET_HOMEDIR(char *homedir_ptr,
                                long homedir_len,
                                struct diagstk *diag_ptr);

void   PSL_GET_HWNAME (long *machine_ptr,
                       char *name_ptr);

unsigned long   PSL_GET_LICDATA (struct diagstk *diag_ptr,
                                 char prd_code,
                                 char *full_pak_ptr,
                                 char *trial_pak_ptr);

void   PSL_GET_LSTERROR (struct diagstk *diag_ptr,
                         unsigned long *errcls_ptr,
                         unsigned long *errnum_ptr);

unsigned long   PSL_GET_MESSAGE (unsigned long msgnum,
                                 char *msgbuf_ptr,
                                 unsigned long bufsiz,
                                 unsigned long msgtyp);

#ifndef VMS
void    PSL_GET_NODEDIR (char *outbuf_ptr,
                         unsigned long outbuf_size);
#endif
unsigned long   PSL_GET_NODENAME (struct diagstk *diag_ptr,
                                  char *nodename_ptr,
                                  unsigned long max_size);

#ifdef UNIX
unsigned long   PSL_GET_PSUSER (struct diagstk *diag_ptr,
                                char *username_ptr,
                                unsigned long username_size,
                                uid_t *uid_ptr,
                                gid_t *gid_ptr);
#endif
unsigned long   PSL_GET_STYP (char *product_name,
                              char *product_code);

unsigned long PSL_GET_TRMALIAS(char *trmnam_ptr,
                               char *alias_ptr,
                               long alias_len,
                               struct diagstk *diag_ptr);

void   PSL_GET_UTILNAME (char *utlnam_ptr,
                         long max_size);


#ifdef UNIX
unsigned long   PSL_GET_WINSIZE(unsigned short *depthp,
                                unsigned short *widthp,
                                struct diagstk *diag_ptr);
#endif /*UNIX*/



void   PSL_LOG_CIOERR (struct diagstk *diag_ptr,
                       unsigned long msgnum,
                       ...);



void   PSL_LOG_EXCEPT (void);

unsigned long   PSL_MODIFY_LOCK     (long *lockblock
                                     ,long *lock_mode
                                     ,long *timeout
                                     ,long *flags);



unsigned long   PSL_PARSE_DATTIM (const char *date_buf,
                                  unsigned long *date_ptr,
                                  unsigned long *time_ptr,
                                  unsigned long dattyp,
                                  unsigned long inflags,
                                  unsigned long *outflags_ptr);



#if 0
TODO alanw - unused
unsigned long   PSL_PRD_DEFINE (char *product_code,
                                short *num_items,
                                short *pak_length,
                                struct pki *pki,
                                char *version);
#endif


void PSL_PREDIAG (struct diagstk *diag_ptr,
                  unsigned long numseg, ...);

void PSL_PREDIAG_L (struct diagstk *diag_ptr,
                    unsigned long numseg,
                    va_list *va_ptr);


unsigned long   PSL_MATCH_CMDWLD (const char *source,
                                  const char *boilerplate,
                                  char command_char);

unsigned long   PSL_MATCH_WILD (const char *source,
                                const char *boilerplate);
char   *PSL_MEMRCHR    (         char *string1_ptr
                                 ,     char string2
                                 ,unsigned long string1_len);

char   *PSL_MEMSTR (         char *string1_ptr
                             ,unsigned long string1_len
                             ,         char *string2_ptr
                             ,unsigned long string2_len);

void   PSL_OUTPUT_DIAG (struct diagstk *diag_ptr,
                        unsigned long context,
                        unsigned long flags);

void   PSL_OUTPUT_DIAGNOSTICS (struct diagstk *diag_ptr,
                               unsigned long context);

#ifdef UNIX
int    PSL_OPEN_PTYM(char *slav_ptr,
                     size_t slav_len,
                     unsigned long flags);

int    PSL_IS_A_STREAMS_PTY(char *pty_name);

#endif /* UNIX */

void   PSL_PUTDIAG (struct diagstk *diag_ptr,
                    unsigned long numseg, ...);

void   PSL_PUTDIAG_L (struct   diagstk *diag_ptr,
                      unsigned long    numseg,
                      va_list *va_ptr);

void   PSL_PUTMSG (unsigned long *message_number, ...);



#ifdef VMS
unsigned long   PSL_READ_BLOCKS (struct RAB *rab,
                                 long *vbn,
                                 void *buf_ptr,
                                 long *size,
                                 struct dsc$descriptor_s *file_name);
#endif



#ifdef UNIX
unsigned long   PSL_REALPATH(char *file_ptr,
                             char *ret_file_ptr,
                             unsigned long max_ret_len,
                             Boolean do_resolve_links);
#endif /* UNIX */


void   PSL_REMOVE_DIAGNOSTICS (struct diagstk *diag_ptr,
                               unsigned long context);

void   PSL_REPLACE_DIAGNOSTIC (struct diagstk *diag_ptr,
                               char *fmt_ptr, ...);

void   PSL_REPLACE_STATDIAG (struct diagstk *diag_ptr,
                             char *msg_ptr);

unsigned long   PSL_RESIGNAL_ERR (struct diagstk *diag_ptr);

#if defined(UNIX) || defined(WIN32)
unsigned long   PSL_RESTOREFILE (struct diagstk *diag_ptr,
                                 const char *filename_ptr);

unsigned long   PSL_SAVEFILE (struct diagstk *diag_ptr,
                              const char *filename_ptr);
#endif

void   PSL_SET_ERRORCTX (struct diagstk *diag_ptr);

void   PSL_SET_UTILNAME (char *util_name);

void   PSL_SETUP_EXCEPT (struct diagstk *diag_ptr);

unsigned long   PSL_SETUP_OUDIAG (struct diagstk *diag_ptr,
                                  unsigned long outtyp,
                                  void *output_ptr,
                                  unsigned long outwid);

void   PSL_SETUP_OUDUSR (struct diagstk *diag_ptr,
                         void *output_ptr,
                         unsigned long outwid,
                         unsigned long (*actrtn_ptr)
                         (void *act_output_ptr,
                          const char *errbuf,
                          unsigned long numlin,
                          unsigned long width));

#if 0
TODO alanw - unused
unsigned long   PSL_SETUP_PRDDATA (struct diagstk *diag_ptr,
                                   char prd_code,
                                   struct prd_data *prd_data_ptr);
#endif


void   PSL_SIG_CIOERR (struct diagstk *diag_ptr,
                       unsigned long msgnum,
                       ...);



void   PSL_SIGDIAG (struct diagstk *diag_ptr,
                    unsigned long numseg, ...);

void   PSL_SIGNAL_ERROR (struct diagstk *diag_ptr,
                         unsigned long errcls,
                         unsigned long errnum);

void   PSL_SLEEP   (unsigned long tenths_second);

unsigned long   PSL_SPAWN (struct diagstk *diag_ptr,
                           const char *command_ptr,
                           unsigned long spawn_flags,
                           const char *outfil_ptr);

unsigned long   PSL_STRING_CMP (char *source,
                                short *source_len,
                                void *keyword,
                                char *result,
                                short *result_len);

unsigned long   PSL_STRING_MOV (char *source,
                                short *source_len,
                                void *keyword,
                                char *result,
                                short *result_len);


unsigned long   PSL_SUBSTR  (char *string1_ptr,
                             unsigned long string1_size,
                             const char *string2_ptr,
                             const char *string3_ptr);


void   PSL_SUPDIAG (struct diagstk *diag_ptr,
                    unsigned long numseg, ...);

void   PSL_SUPDIAG_L (struct   diagstk *diag_ptr,
                      unsigned long    numseg,
                      va_list *va_ptr);

void   PSL_TAG_QSORT (void *arr_base,
                      size_t num_elem,
                      size_t arr_size,
                      unsigned long *tag_base,
                      int (*compar)(void *, void *, void *),
                      void *user_ptr);


#ifdef UNIX
unsigned long   PSL_TEST_CTRLTRM(char *devicenamep,
                                 Boolean *matchp,
                                 struct diagstk *diag_ptr);
#endif /*UNIX*/


unsigned long   PSL_TPARSE   (struct tpaarg *,
                              struct tpatab *);

void        PSL_TPATRACE (struct tpaarg *argblk_ptr,
                          short type);



unsigned long   PSL_TRAP_ERRORS (struct diagstk *diag_ptr,
                                 unsigned long  errcls,
                                 unsigned long  errnum,
                                 unsigned long  response,
                                 jmp_buf    *jmp_ptr,
                                 unsigned long (*handler) (
                                     struct diagstk *,
                                     unsigned long,
                                     unsigned long));





unsigned long PSL_TRIM_FILESPEC (char *inp_file_ptr,
                                 char *out_file_ptr,
                                 unsigned long max_out_len,
                                 unsigned long flags);


/*
 *    Function prototypes for the new linked list routines
 */
unsigned long PSL_VM_INITIALIZE   (unsigned long size,
                                   struct psl_vm_llb **list_id);

unsigned long   PSL_VM_INSERT   (struct   psl_vm_llb *list_ptr,
                                 char       *buff_ptr,
                                 char       *pos_ptr,
                                 char       **ctx_ptr,
                                 unsigned long       position);

unsigned long   PSL_VM_REMOVE   (struct   psl_vm_llb *list_ptr,
                                 char       *buff_ptr,
                                 char       *pos_ptr,
                                 char       **ctx_ptr,
                                 unsigned long       position);

unsigned long   PSL_VM_COPY    (struct   psl_vm_llb *list_ptr,
                                char       *buff_ptr,
                                char       *pos_ptr,
                                char       **ctx_ptr,
                                unsigned long       mode);

unsigned long   PSL_VM_DELETE (struct psl_vm_llb *list_ptr);



unsigned long   PSL_VM_SORT (struct psl_vm_llb **user_list,
                             unsigned long *user_cnt_ptr,
                             unsigned long ent_size,
                             struct psl_vm_skey *key_ptr,
                             unsigned long options,
                             struct diagstk *diagstk);




#ifdef VMS
unsigned long   PSL_WRITE_BLOCKS (struct RAB *rab,
                                  long *vbn,
                                  void *buf_ptr,
                                  long *size,
                                  struct dsc$descriptor_s *file_name);
#endif



unsigned long   PSLMEM_MAP_FILE (struct diagstk *diag_ptr,
                                 char *filnam_ptr,
                                 struct pslmem_ctx *pslmem_ctx_ptr);

unsigned long   PSLMEM_MAP_PROC (struct diagstk *diag_ptr,
                                 long pid,
                                 struct pslmem_ctx *pslmem_ctx_ptr);

unsigned long   PSLMEM_READ (struct diagstk *diag_ptr,
                             struct pslmem_ctx *pslmem_ctx_ptr,
                             void *start_ptr,
                             void *buf_ptr,
                             unsigned long length,
                             unsigned long flags);


unsigned long   PSLMEM_SNAP_PROC (struct diagstk *diag_ptr,
                                  long    pid,
                                  char    *filnam_ptr);

unsigned long   PSLMEM_REG_SNAP  (struct diagstk *diag_ptr);


#ifdef WIN32
void    PSLMEM_UNMAP_FILE (struct diagstk *diag_ptr,
                           struct pslmem_ctx *pslmem_ctx_ptr);

void    PSLMEM_UNMAP_PROC (struct diagstk *diag_ptr,
                           struct pslmem_ctx *pslmem_ctx_ptr);
#endif /* WIN32 */


#ifdef VMS
unsigned long   PSLVMS_COPY_DSC (char *product_code,
                                 struct dsc$descriptor_s *main_pak,
                                 struct dsc$descriptor_s *trial_pak);
#endif


/*
 *    Function prototypes for the old (VMS specific) linked list routines
 *    and those for the new ('C') versions of these routines.
 */
unsigned long   PSLVMS_VM_COPY (char *(*list_id), ...);

unsigned long   PSLVMS_VM_DELETE (char *(*list_id));

unsigned long   PSLVMS_VM_INITIALIZE (unsigned short *size, char *(*list_id));

unsigned long   PSLVMS_VM_INSERT (char *(*list_id), char *item, ...);

unsigned long   PSLVMS_VM_REMOVE (char *(*list_id), ...);



void   RESET_STATUS  (unsigned long *new_status,
                      unsigned char *flags);

void   RESET_TERMINAL (void);

void   SET_CONTROL_T (void (*outrtn)(void *),
                      void *user_ptr);

#ifdef VMS
void   SETUP_COMMON_MSG (void);

void   SETUP_PUTMSG (unsigned long (*actrtn)(struct dsc$descriptor_s *,
                     struct diagstk *), ...);
#endif

unsigned long   STR_COMPARE (char *buffer1,
                             unsigned long *count,
                             char *buffer2);

unsigned long   STR_COPY (char *buffer1,
                          unsigned long *count,
                          char *buffer2);

void   STR_EXPAND_CTL (char cmdchr,
                       char ctlchr,
                       long ctlmnc,
                       char *inpstr_ptr,
                       long inpstrlen,
                       char *outstr_ptr,
                       long outbuflen,
                       long *uncnvcnt_ptr,
                       long flags);

unsigned long   STR_FILL (char *buffer,
                          unsigned long *count,
                          char *filler);

#ifdef VMS
void   STR_LOWCASE (struct dsc$descriptor_s *src,
                    struct dsc$descriptor_s *dst);
#endif

unsigned long   STR_REFORMAT_TEXT (char *inpbuf,
                                   unsigned short *inplen,
                                   char *outbuf,
                                   unsigned short *width,
                                   unsigned short *maxlin,
                                   unsigned short *numlin);

unsigned long   STR_REPLACE_NONPRINTING (char *buffer,
        unsigned long count,
        char filler);
#ifdef VMS
unsigned long   STRING_LENGTH (struct dsc$descriptor_s *string);
#endif

unsigned long   PSL_DECODE_FKEY (     char *inp_string
                                      ,unsigned long inp_string_length
                                      ,         char *out_string
                                      ,unsigned long *out_string_length);

#ifdef  VMS
void   USER_GET_PRCDATA    (    char enable_flag
                                ,    long *newprv_msk
                                ,        char prmflg
                                ,    long *oldprv_msk);
#endif  /* VMS */


unsigned long   VRF_CLOSE (struct vrf_fil *vrfptr,
                           unsigned long stsflg);

unsigned long   VRF_OPEN (struct vrf_fil **vrfptr_ptr,
                          char *filnam_ptr,
                          struct diagstk *diag_ptr,
                          unsigned long access_flags,
                          long util_version,
                          void *usrhdr_ptr,
                          char *expfil_ptr);

unsigned long   VRF_READ (struct vrf_fil *vrfptr,
                          void *vrfrec,
                          long *retlen);

unsigned long   VRF_WRITE (struct vrf_fil *vrfptr,
                           void *vrfrec);

#endif  /* PSL__PSL_RTNDEF_LOADED */
