#ifndef PSL__PSL_TPATABDEF_LOADED
#define PSL__PSL_TPATABDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N  ****                  */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: PSL_TPATABDEF               */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  TPARSE State Table Data Structure.                   */
/*                                       */
/*===========================================================================*/

/*** MODULE PSL_TPATABDEF ***/


/*    TPARSE State Table Entry */

struct tpatab
{

    /*    End of State Flag */

    char                    end_stateb;

    /*    Token type */

    char                    token_typeb;
#define            PSLTPA_CHAR 0
#define            PSLTPA_KEYWORD 1
#define            PSLTPA_ANY 2
#define            PSLTPA_ALPHA 3
#define            PSLTPA_DIGIT 4
#define            PSLTPA_STRING 5
#define            PSLTPA_SYMBOL 6
#define            PSLTPA_BLANK 7
#define            PSLTPA_DECIMAL 8
#define            PSLTPA_OCTAL 9
#define            PSLTPA_HEX 10
#define            PSLTPA_LAMBDA 11
#define            PSLTPA_EOS 12
#define            PSLTPA_SUBXPR 13
#define            PSLTPA_QUOTED 14
#define            PSLTPA_DATANAME 15
#define            PSLTPA_EXPRESSION 16
#define            PSLTPA_LONGDATANAME 17

    /*    Token char */

    unsigned char           token_charb;

    /*    Quit type */

    char                    quitb;
#define            PSLTPA_EXIT 1
#define            PSLTPA_FAIL 2

    /*    Keyword pointer */

    char                    *keyword_ptrpc;

    /*    Subexpression pointer */

    struct tpatab           *subexpr_ptrps;

    /*    Target state */

    struct tpatab           *target_ptrps;

    /*    Action routine pointer */

    PSL_U_LONGWORD_T        (*action_ptrpf)
    (struct tpaarg *argblk_ptr)
    ;

    /*    Action routine parameter */

    PSL_LONGWORD_T          action_paraml;

    /*    Data pointer */

    void                    *data_ptrp;

    /*    Data mask */

    PSL_LONGWORD_T          maskl;

    /*    The following fields are for tracing: */

    /*    Pointer to state name */

    char                    *stanam_ptrpc;

    /*    Pointer to sub-expression name */

    char                    *subnam_ptrpc;

    /*    Pointer to target state name */

    char                    *tgtnam_ptrpc;

    /*    Pointer to action routine name */

    char                    *actnam_ptrpc;
} ;



/*  End of C Include File */

#endif  /* PSL__PSL_TPATABDEF_LOADED */
