/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// The following macros query the belonging of a character to a given class:
#define IS_BASECHAR(x)          ((BOOL)(CharClass[x] & 1))
#define IS_IDEOGRAPHIC(x)       ((BOOL)(CharClass[x] & 2))
#define IS_COMBININGCHAR(x)     ((BOOL)(CharClass[x] & 4))
#define IS_DIGIT(x)             ((BOOL)(CharClass[x] & 8))
#define IS_EXTENDER(x)          ((BOOL)(CharClass[x] & 16))
#define IS_PUBIDCHAR(x)         ((BOOL)(CharClass[x] & 32))
#define IS_LETTER(x)            ((BOOL)(CharClass[x] & 3))
#define IS_FIRSTNAMECHAR(x)     ((BOOL)(IS_LETTER(x) || x=='_' || x==':'))
#define IS_NAMECHAR(x)          ((BOOL)((CharClass[x] & 31) || x=='.' || x=='-' || x=='_' || x==':'))
#define IS_NCNAME_FIRSTCHAR(x)  ((BOOL)IS_LETTER(x) || x=='_')
#define IS_NCNAME_OTHERCHAR(x)  ((BOOL)((CharClass[x] & 31) || x=='.' || x=='-' || x=='_'))

extern const BYTE CharClass[];
extern const DWORD dwNbCharClassElements;
