#if !defined(AFX_ARCHITECTUREMANAGER_H__BC506363_777B_11D5_B383_00A024CBE341__INCLUDED_)
#define AFX_ARCHITECTUREMANAGER_H__BC506363_777B_11D5_B383_00A024CBE341__INCLUDED_
/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ArchitectureManager.h : header file
//

#include <InjectorControl.h>
#include "ArchMgrHost.h"
#include "ArchMgrSystem.h"
#include "ArchMgrRepository.h"
#include "OSTAORB/OSTAORB.h"

struct OstaHost
{
    CString strName;
    CString strIPAddrUnderscores;
    CString strIPAddrDots;
    CString strHostFileName;
	BOOL bIsWeb;
} typedef OstaHost;
typedef CList<OstaHost,OstaHost&> OstaHostList;

struct RepHost
{
    CString strName;
    CString strIPAddrUnderscores;
    CString strIPAddrDots;
    CString strHostFileName;
	BOOL bIsWeb;
    OstaHostList ostaHosts;
    RepHost& operator=(RepHost& myHost)
    {
        strName = myHost.strName;
        strIPAddrUnderscores = myHost.strIPAddrUnderscores;
        strIPAddrDots = myHost.strIPAddrDots;
        strHostFileName = myHost.strHostFileName;
	    POSITION pos = myHost.ostaHosts.GetHeadPosition();
	    while(pos)
	    {
	        OstaHost &ostaHost = myHost.ostaHosts.GetNext(pos);
            ostaHosts.AddTail(ostaHost);
        }
        return *this;
    };
} typedef RepHost;
typedef CList<RepHost,RepHost&> RepHostList;

struct IPADDR
{
	int byte1;
	int byte2;
	int byte3;
	int byte4;
} typedef IPADDR;

/////////////////////////////////////////////////////////////////////////////
// CArchitectureManager dialog

class CArchitectureManager : public CDialog
{
// Construction
public:
	CArchitectureManager(CWnd* pParent = NULL);   // standard constructor
    void Scan();
    OstaHost m_selOstaHost;

// Dialog Data
	//{{AFX_DATA(CArchitectureManager)
	enum { IDD = IDD_ARCHITECTURE_MANAGER };
	CTabCtrl	m_ArchMgrTab;
	CTreeCtrl	m_OstaHostTree;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CArchitectureManager)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
    CImageList m_ArchMgrImages;
    CImageList m_ArchMgrTabImages;

	// Generated message map functions
	//{{AFX_MSG(CArchitectureManager)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnRefresh();
	afx_msg void OnSelchangedOstaHostTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeArchMgrTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRclickOstaHostTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnStartnameserver();
	afx_msg void OnStopnameserver();
	afx_msg void OnShutdown();
	afx_msg void OnUpdateStartnameserver(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStopnameserver(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void RunScan();
    void NSScan();
    void AddHost(OstaHost RepHost, OstaHost OstaHost);
    void GetHost(CString inHostName, OstaHost &outOstaHost);
    bool myCORBAServer(int argc,char** argv);
    CString GetStringValue(HKEY hKeyParent, LPCTSTR lpszKeyName, LPCTSTR lpszField);
    void RefreshArchMgr();
    int StartProcess(CString& strCommand ,HANDLE* pReturnHandle ,DWORD* pReturnPid);
    void StopOSTADaemon();

    CString m_strCmdrIPAddrDots;
    CString m_strCmdrIPAddrUnderscores;
    CString m_strCmdrHostName;
    RepHostList m_RepHosts;
    CString m_strOpenSTAHome;
    CArchMgrHost* m_pArchMgrHost;
    CArchMgrSystem* m_pArchMgrSystem;
    CArchMgrRepository* m_pArchMgrRepository;

	CORBAServer* m_pCorba;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ARCHITECTUREMANAGER_H__BC506363_777B_11D5_B383_00A024CBE341__INCLUDED_)
