/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// scleditor.cpp : implementation file
//

#include "stdafx.h"
#include "SCLEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSCLEditor

CSCLEditor::CSCLEditor()
{
	// Register CodeMax
	CMRegisterControl();

    m_Language.dwStyle          = CMLS_PROCEDURAL;
    m_Language.bIsCaseSensitive = FALSE;
    m_Language.pszOperators     = _T("+\n-\n*\n/\n|\n<^>\n<=\n<>\n<\n>=\n>\n=\n^\n&\n"
                                     "AND\nCONTAINS\nNOT\nNOT_CONTAINS\nOR\n\0");

    m_Language.pszSingleLineComments = _T("!");
    m_Language.pszMultiLineComments1 = _T("");
    m_Language.pszMultiLineComments2 = _T("");
    m_Language.pszScopeKeywords1     = _T("");
    m_Language.pszScopeKeywords2     = _T("");
    m_Language.pszStringDelims       = _T("'\n\"\n\0"); // Allow single or double quotes
    m_Language.chEscape              = NULL;
    m_Language.chTerminator          = NULL;
    m_Language.pszTagElementNames    = NULL;
    m_Language.pszTagAttributeNames  = NULL;
    m_Language.pszTagEntities        = NULL;

	char *szBuffer = "ABORT\nACQUIRE\nACTIVE_THREADS\nAPPEND\nAS\nAT\nBINARY\n"
                          "CALL\nCANCEL\nCASE_BLIND\nCHARACTER\nCLEAR\nCLOSE\nCODE\n"
                          "COMMAND\nCOMMA-SEPARATED\nCONSTANT\nCONTROL\nCONVERT\nDATE\n"
                          "DEFINE\nDEFINITIONS\nDESCRIPTION\nDETACH\n"
                          "DO\nELSEIF\nELSE\nENDDO\nENDIF\nEND\nENTRY\nENVIRONMENT\n"
                          "ERROR\nEXIT\nFAIL\nFILE\nFORMAT\nFOR\nGENERATE\nGLOBAL\nGOTO\n"
                          "HISTORY\nHTTP\nIF\nINCLUDE\nINPUT\nINTEGER\nKEEPALIVE\nLOAD\n"
                          "LOCAL\nLOG\nMILLISECONDS\nMODE\nMUTEX\nNEXT\nNO-COMMA\n"
                          "NODENAME\nNOSHARED\nNOTE\nON\nOPEN\nOUTPUT\nPASS\nRANDOM\n"
                          "READ\nRELEASE\nREPEATABLE\nREPORT\nRESET\nRETURN\nREWIND\n"
                          "SCRIPT\nSECONDS\nSEED\nSEMAPHORE\nSET\nSHARED\nSTART\n"
                          "SUBROUTINE\nTARGET\nTEST-CASE\nTEST-WIDE\nTEST\nTHEN\nTHREAD\n"
                          "TIMEOUT\nTIMER\nTIME\nTRACE\nUNIT\nWAIT\nWRITE\n"
                          "#ELIF\n#ELSE\n#ENDIF\n#IFDEF\n#IFNDEF\n#INCLUDE\n"
                          "~EXTRACT\n~LOCATE\n~LENGTH\n~LEFT\n~RIGHT\n~RTRIM\n~LTRIM\n"
						  "CERTIFICATE\nNAME\nGET\nPOST\nHEAD\n"
						  "CONNECT\nDISCONNECT\n"
                          "SYNCHRONISE\nSYNCHRONIZE\nREQUESTS\nLOAD\nRESPONSE_INFO\n"
                          "HEADER\nBODY\nWITH\nWITHOUT\nINTO\nTO\nON\nFROM\nBINARY\n"
                          "URI\nURL\nALL\nCANCEL\nRESPONSE\nTIMER\nRETURNING\nSTATUS\n"
                          "CODE\nTIMEOUT\nGOTO\nPRIMARY\n\0";

	char *szKeywords = new char[ strlen(szBuffer)+1];
	strcpy(szKeywords,szBuffer);
	m_Language.pszKeywords = szKeywords; 

	//m_OSLanguage.SetComments("!");
}

CSCLEditor::~CSCLEditor()
{
	delete [](LPVOID)(m_Language.pszKeywords);
}


BEGIN_MESSAGE_MAP(CSCLEditor, CCodeMaxCtrl)
	//{{AFX_MSG_MAP(CSCLEditor)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSCLEditor message handlers

int CSCLEditor::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CCodeMaxCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	EnableColorSyntax(TRUE);

    CMRegisterLanguage( "HTTPSCL" , &m_Language );
    SetLanguage("HTTPSCL");
	EnableDragDrop(FALSE);
	
	return 0;
}

void CSCLEditor::PreSubclassWindow() 
{
	EnableColorSyntax(TRUE);

    CMRegisterLanguage( "HTTPSCL" , &m_Language );
    SetLanguage("HTTPSCL");
	EnableDragDrop(FALSE);

	CWnd::PreSubclassWindow();
}
