/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(PROPERTIESBAR_INCLUDED)
#define PROPERTIESBAR_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PropertiesBar.h : header file
//

#include "TaskGroupDlg.h"
#include "HostDlg.h"
#include "ScriptDefData.h"
#include "TaskGroupDefData.h"
#include "VUsDlg.h"
#include "ScriptTaskDlg.h"
#include "TaskGroupInfoDlg.h"
#include "CORBAInfo.h"

#define IDT_UPDATE_PROPBAR 3

class CTestFile;
/////////////////////////////////////////////////////////////////////////////
// PropertiesBar
class CPropertiesBar : public CSizingControlBarG
{
// Construction
public:
	void SetTestActive();
	void StopActiveTest();

	CPropertiesBar(CWnd* pParent = NULL);   // standard constructor

	void Activate(CTestFile* pTestFile,HWND hwndNotify,const CString& strRegName);

	void Edit(int nRow, int nColumn);
	BOOL EditNothing();
	BOOL EditTaskGroupInfo(int nGroup);
	BOOL EditScheduling(int nGroup);
	BOOL EditScriptTask(int nGroup,int nTask);
	BOOL EditHost(int nGroup);
	BOOL EditVUs(int nGroup);
	BOOL EditProfileTask(int nGroup);
	BOOL EditStartStop(int nGroup);

	void Refresh();
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPropertiesBar)
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPropertiesBar)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC *pDC);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	BOOL m_bNotEditable;
	BOOL m_bTestActive;

	CTestFile* m_pTestFile;

	CTaskGroupDlg m_dlgTaskGroup;
	CHostDlg m_dlgHost;
	CVUsDlg m_dlgVUs;
	CTaskGroupInfoDlg m_dlgTaskGroupInfo;

	CScriptTaskDlg m_dlgScriptTask;

	CDialog *m_pActivePage;
	HWND m_hwndNotify;

	int m_nLastColumn;
	int m_nLastRow;

	BOOL GetTestActive();
	void ShowDialog(CDialog *pDlg,int nGroup);
	BOOL GetTaskGroupCannotBeEdited(int nGroup);
	TGExecStatus GetTaskGroupStatus(int nGroup);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(PROPERTIESBAR_INCLUDED)
