/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_MONITORVU_H__715FA533_32F9_4E6C_A0C8_5F919AA2808E__INCLUDED_)
#define AFX_MONITORVU_H__715FA533_32F9_4E6C_A0C8_5F919AA2808E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonitorVU.h : header file
//

#include "xchartctrl.h"
/////////////////////////////////////////////////////////////////////////////
// CMonitorVU window

class CMonitorVU : public CWnd
{
// Construction
public:
	CMonitorVU();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonitorVU)
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL UpdateGraph();
	BOOL Init(CString path);
	CXChartCtrl* CreateDisplay();
	virtual ~CMonitorVU();

	// Generated message map functions
protected:
	//{{AFX_MSG(CMonitorVU)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg	void ToggleRollingGraphs();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point) ;
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int	m_nIntervalDisplaying;	// The data displaying interval in milliseconds
	CXChartCtrl* m_pChart;
	void LoadGraphStyles();
	int GetNextField(char sep, CString &inStr, CString &field);

	CString m_strTestRunPath;
	int m_nRollingChecked;
	
	CStdioFile m_dataFile;
	BOOL m_bDataFileOpen;
	DWORD m_nFilePos;

    COLORREF m_colPlotBk;
    CString  m_strLabelFont;
    COLORREF m_colGrid;
    COLORREF m_colLabel;
    COLORREF m_colAxisText;
	CDWordArray m_arDefLineColours;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONITORVU_H__715FA533_32F9_4E6C_A0C8_5F919AA2808E__INCLUDED_)
