/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_MONITORINGBAR_H__FF0CA2A3_4857_11D5_94F1_00C04F89E392__INCLUDED_)
#define AFX_MONITORINGBAR_H__FF0CA2A3_4857_11D5_94F1_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonitoringBar.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMonitoringBar dialog
class CTestFile;
class CMonitoringBar : public CSizingControlBarG
{
// Construction
public:
	CMonitoringBar(CWnd* pParent = NULL);   // standard constructor

	void SetNotifyWindow(HWND hWndNotify)
	{
		m_hWndNotify = hWndNotify;
	}

	void Refresh();
	void SetTestFile(CTestFile *pTestFile);
	void SetTestStatus(const CString& strStatus);
	void EnableTree(BOOL bEnable);
	
	CTreeCtrl	m_ctlMonitorTree;
	CStatic		m_ctlTestStatus;
	CButton		m_ctlTestStatusBox;

	struct NM_MONITOR
	{
		CString strTargetType;
		CString strScreenName;
		int nTaskGroup;

		BOOL operator==(NM_MONITOR& mon)
		{
			return ((mon.strTargetType == strTargetType) && 
				(mon.strScreenName == strScreenName) && 
				(mon.nTaskGroup == nTaskGroup));
		}

	};

	void SetCheck(NM_MONITOR& monInfo,BOOL bCheck);
	void ClearAllChecks();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonitoringBar)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMonitoringBar)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClickMonitorTree(NMHDR* pNMHDR, LRESULT* pResult) ;
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	HWND m_hWndNotify;
	CImageList m_ImageList;
	CTestFile *m_pTestFile;
	CMap <HTREEITEM,HTREEITEM,NM_MONITOR,NM_MONITOR&> m_mapItemToType;
	CFont m_fontStatus;
	BOOL m_bEnabled;

	void SaveBranchState(HTREEITEM hBranch,const CString& strFolder,CMap <CString,LPCTSTR,UINT,UINT>&);
	void RestoreBranchState(HTREEITEM hBranch,const CString& strFolder,CMap <CString,LPCTSTR,UINT,UINT>&);

	void ClearChecksOnBranch(HTREEITEM hBranch);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONITORINGBAR_H__FF0CA2A3_4857_11D5_94F1_00C04F89E392__INCLUDED_)
