#if !defined(AFX_STEPBYSTEPDLG_H__7A8CEE4A_E5F3_455C_9B44_7C12B29331C2__INCLUDED_)
#define AFX_STEPBYSTEPDLG_H__7A8CEE4A_E5F3_455C_9B44_7C12B29331C2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StepByStepDlg.h : header file
//

#include "resource.h"
#include "SCLParser.h"
#include "SCLEditor.h"
#include "CECGridCtrl.h"
#include "HttpSingleStepFile.h"

class CNoFlickerTabCtl : public CTabCtrl
{
public:
	CNoFlickerTabCtl(){}
	virtual ~CNoFlickerTabCtl(){}

	//{{AFX_VIRTUAL(CNoFlickerTabCtl)
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CNoFlickerTabCtl)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////
// CStepByStepDlg dialog
class CStepByStepProxy;
class CStepByStepPlugin;
class CStepByStepDlg : public CDialog
{
// Construction
public:
	friend CStepByStepProxy;
	CStepByStepDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CStepByStepDlg();

	void SetTestActive(const CString& strReg);
	void StopActiveTest();

	BOOL IsTestRunning()
	{
		return m_bTestRunning;
	}

// Dialog Data
	//{{AFX_DATA(CStepByStepDlg)
	enum { IDD = IDD_SBS_DLG };
	CComboBox	m_ctlScriptList;
	CComboBox	m_ctlVUs;
	CNoFlickerTabCtl	m_ctlConfigTabs;
	CNoFlickerTabCtl	m_ctlTestOutputTabs;
	CRichEditCtrl	m_ctlHttpOutput;
	CStatic	m_ctlTasksCpn;
	CListBox	m_ctlTasks;
	CStatic	m_ctlProfilesCpn;
	CListBox	m_ctlProfiles;
	CButton	m_ctlAdvanced;
	CButton	m_ctlSingleUser;
	CButton m_ctlMultiUser;
	int		m_nUserMode;
	//}}AFX_DATA
	CSCLEditor m_ctlScript;	
	CECGridCtrl m_ctlScriptDetails;
	CECGridCtrl m_ctlUserStatus;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStepByStepDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CStepByStepDlg)
	afx_msg void OnAdvanced();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeConfigTabs(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeOutputTabs(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeProfiles();
	afx_msg void OnSelchangeTasks();
	afx_msg void OnShowTransTimers();
	afx_msg void OnUpdateShowTransTimers(CCmdUI* pCmdUI);
	afx_msg void OnShowWaits();
	afx_msg void OnUpdateShowWaits(CCmdUI* pCmdUI);
	afx_msg void OnShowcomments();
	afx_msg void OnUpdateShowcomments(CCmdUI* pCmdUI);
	afx_msg void OnShowsecondaryurls();
	afx_msg void OnUpdateShowsecondaryurls(CCmdUI* pCmdUI);
	afx_msg void OnShowtimers();
	afx_msg void OnUpdateShowtimers(CCmdUI* pCmdUI);
	afx_msg void OnStep();
	afx_msg void OnUpdateStep(CCmdUI* pCmdUI);
	afx_msg void OnStop();
	afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
	afx_msg void OnRun();
	afx_msg void OnUpdateRun(CCmdUI* pCmdUI);
	afx_msg void OnBreak();
	afx_msg void OnUpdateBreak(CCmdUI* pCmdUI);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnToggleBreakpoint();
	afx_msg void OnSelchangeVus();
	afx_msg void OnGotoScript();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelchangeScriptList();
	afx_msg void OnMultiUser();
	afx_msg void OnSingleUser();
	afx_msg void OnShowCallscripts();
	afx_msg void OnUpdateShowCallscripts(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnCellCheckedScriptDetails(NMHDR* pNMHDR,LRESULT* pResult);
	afx_msg void OnDblClickScriptDetails(NMHDR* pNMHDR,LRESULT* pResult);
	afx_msg void OnRClickScriptDetails(NMHDR* pNMHDR,LRESULT* pResult);
	afx_msg void OnDblClickUserStatus(NMHDR* pNMHDR,LRESULT* pResult);
	afx_msg LRESULT OnNextRequest(WPARAM,LPARAM);
	afx_msg LRESULT OnRequestComplete(WPARAM,LPARAM);
	afx_msg LRESULT OnReadyToStep(WPARAM,LPARAM);
	afx_msg LRESULT OnRunning(WPARAM,LPARAM);
	afx_msg LRESULT OnRequestStepped(WPARAM,LPARAM);
	DECLARE_MESSAGE_MAP()

	const CString m_cstrStandard,m_cstrAdvanced;	//text to show on advanced button
	void DisplayStandardMode();
	void DisplayAdvancedMode();

	void SizeTaskGroupInfoCtrls(const CRect& rcBounds);
	void SizeTestOutputCtrls(const CRect& rcBounds);
	void SizeTestConfigCtrls(const CRect& rcBounds);

	void SetupTestOutputTabs();
	void SetupTestConfigTabs();
	void SetupTaskGroupInfoCtrls();

	//Horizontal splitter members
	BOOL IsOnSplitter(const CPoint& pt);
	void DrawDragHSplitter(int nOldPos=-1,int nNewPos=-1);
	void DoSizing();

	void FillScriptDetailsList();
	void HighlightLine(int nLineNumber);
	void HighlightScriptLine(int nLineNumber);
	void HighlightScriptDetailLine(int nLineNumber);
	void DisplayScript(	const CString& strScript);
	void ShowConfigTab(int nTab);
	void SetConfigReadOnly(BOOL bReadOnly,BOOL bMonitoring,BOOL bScript);
	void DisplayUserStatus(CNextRequestData*);
	void RemoveUserStatus(const CString& strUserKey);

	BOOL IsBreakpoint(int nLine);
	BOOL IsHttpMonitoringEnabled(const CString&,int nLine);
	BOOL SetBreakpoint(int nLine,bool bSet = true);
	void SetHTTPMonitor(int nLine,bool bSet = true);
	BOOL StartTest(BOOL);
	void GetUserKey(int nVU,int nCon,CString& strKey);
	int GetNumVUs();
	
	DWORD GetMonitoring(const CString& strScript,const CString& strProfile,int nLine);
	void SetMonitoring(const CString& strScript,const CString& strProfile,int nLine,DWORD dwState);
			
	CString GetTestRunFolder();
	void DisplayNextRequest(CNextRequestData* pNRD);
	void DisplayRequestComplete(CRequestCompleteData* pRCD);
	void DisplayResultsForUser(int nVUId = -1);

	void ResetData();
	void SaveScriptData();
	void LoadScriptData(const CString& strScript);
	BOOL LoadMonitoringData(const CString& strScript,const CString& strProfile,const CString& strPath,DWORD dwDefaultState);
	void LoadMonitoringData(const CString& strScript,const CString& strProfile);

	void SaveMonitoringData(const CString& strScript,const CString& strProfile,const CString& strPath);
	void SaveMonitoringData();

	CString GetConfigFilePath(const CString& strScript,const CString& strProfile);

private:
	//Horizontal splitter members
	int m_nHSplitterPos;
	bool m_bDraggingHSplitter;

	CStepByStepProxy* m_pComms;

	BOOL m_bAdvancedMode;
	BOOL m_bTestRunning;
	BOOL m_bEnableBreak;
	BOOL m_bEnableRun;
	
	CString m_strRunFolder;
	CString m_strOpenScript;
	CString m_strOpenProfile;

	CWnd *m_pCurrentConfigView;
	CWnd *m_pCurrentOutputView;

	typedef struct
	{
		CString strName;
		CString strPlugin;
		CWnd *pView;
		CStepByStepPlugin* pPlugin;
		DWORD dwDefaultMonitoring;
	}TabData;
	CArray <TabData,TabData> m_arTestOutputTabs; 
	
	CArray <CStepByStepPlugin*,CStepByStepPlugin*> m_arPlugins;

	DWORD m_dwScriptDetailsFilter;
	CSclParser m_sclParser;

	CMap <int,int,int,int> m_mapScriptLineToRow;
	CStringArray m_arstrScriptDetailsColumns;

	CMap <CString,LPCTSTR,CNextRequestData*,CNextRequestData*> m_mapVUToRequest;
	CMap <CString,LPCTSTR,BOOL,BOOL> m_mapVUToMonitor;
	CMap <CString,LPCTSTR,int,int> m_mapPathToScriptListNdx;
	
	typedef CMap<int,int,DWORD,DWORD&> LineToStateMap;
	typedef CMap<CString,LPCTSTR,LineToStateMap*,LineToStateMap*> ProfileToLineMap;
	CMap <CString,LPCTSTR,ProfileToLineMap*,ProfileToLineMap*> m_ScriptToProfileMap;

	CArray <CWnd*,CWnd*> m_arConfigTabs;

	int m_nCurrentVUId;
	int m_nSelectedLine;
	int m_nNumVUs;
	CPoint m_ptContextClick;
	CTime m_timeOpenScript;
	CNextRequestData *m_pLastRequest;

	//Value of enBreakpoint must be 2,4, or 8 because it is used in setmarginimages
	//cos it uses bits to work out image to use and pos 1 doesn;t work
	typedef enum{enScriptTabImg,enBreakpoint,enListTabImg,enPrimary,enSecondary,enStartTimer,enEndTimer,
				enComment,enCallScript,enHighlight,enWait,enTransStartTimer,enTransEndTimer,enUsersTabImg}Images;

	typedef enum{enSingleUserMode,enMultiUserMode} UserMode;
	CImageList m_ImageList;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STEPBYSTEPDLG_H__7A8CEE4A_E5F3_455C_9B44_7C12B29331C2__INCLUDED_)
