/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TestMonitorPlugin.cpp: implementation of the CTestKitPlugin class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TestMonitorPlugin.h"
#include "PluginTypes.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

typedef BOOL	( * LPCHECKEXTFUNC)			(CString strExt);
typedef void	( * LPGETSCREENS)			(CTestFile* pTestFile, int nGroup, CStringArray& arrScreens);
typedef CWnd* 	( * LPVIEWSCREEN)			(CString strManagerReg, CString strTestRunPath, CStringArray& arrScreens, CWnd* pParent);
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTestMonitorPlugin::CTestMonitorPlugin(CString szTitle,CPluginManager* pPluginManager)
{
	m_pPlugin = pPluginManager->GetPlugin(TEST_MONITOR_PLUGIN, szTitle);
}

CTestMonitorPlugin::~CTestMonitorPlugin()
{

}

BOOL CTestMonitorPlugin::IsSupportedExtension(CString strExt)
{
	LPCHECKEXTFUNC proc = (LPCHECKEXTFUNC)m_pPlugin->GetFunction("IsSupportedExtension");
	if (!proc)
	{
		AfxMessageBox("Error invoking dll");
		return 0;
	}
	return proc(strExt);
}

CString CTestMonitorPlugin::GetPackage()
{
	return m_pPlugin->GetPackage();
}

void CTestMonitorPlugin::GetAvailableScreens(CTestFile* pTestFile, int nGroup, CStringArray& arrScreens)
{
	LPGETSCREENS proc = (LPGETSCREENS)m_pPlugin->GetFunction("GetAvailableScreens");
	if (!proc)
	{
		AfxMessageBox("Error invoking dll");
		return ;
	}
	proc(pTestFile, nGroup, arrScreens);
}

CWnd*  CTestMonitorPlugin::ViewScreen(CString strManagerReg, CString strTestRunPath, CStringArray& arrScreens, CWnd* pParent)
{
	LPVIEWSCREEN proc = (LPVIEWSCREEN)m_pPlugin->GetFunction("ViewScreen");
	if (!proc)
	{
		AfxMessageBox("Error invoking dll");
		return NULL;
	}

	return proc(strManagerReg, strTestRunPath, arrScreens, pParent);
}
