/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XChartCtrlCtl.cpp : Implementation of the CXChartCtrlCtrl ActiveX Control class.

#include "stdafx.h"
#include "XChartCtrl.h"
#include "XChartCtrlCtl.h"
#include "XChartCtrlPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CXChartCtrlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CXChartCtrlCtrl, COleControl)
//{{AFX_MSG_MAP(CXChartCtrlCtrl)
ON_WM_CREATE()
ON_WM_SIZE()
ON_WM_ERASEBKGND()
//}}AFX_MSG_MAP
ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CXChartCtrlCtrl, COleControl)
//{{AFX_DISPATCH_MAP(CXChartCtrlCtrl)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "TitleText", GetTitleText, SetTitleText, VT_BSTR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "TitleBkColor", GetTitleBkColor, SetTitleBkColor, VT_COLOR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "PlotBkColor", GetPlotBkColor, SetPlotBkColor, VT_COLOR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "YAxisLabel", GetYAxisLabel, SetYAxisLabel, VT_BSTR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "XAxisLabel", GetXAxisLabel, SetXAxisLabel, VT_BSTR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "Y2AxisLabel", GetY2AxisLabel, SetY2AxisLabel, VT_BSTR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "YAxisMinimum", GetYAxisMinimum, SetYAxisMinimum, VT_I4)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "XAxisMinimum", GetXAxisMinimum, SetXAxisMinimum, VT_I4)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "Y2AxisMinimum", GetY2AxisMinimum, SetY2AxisMinimum, VT_I4)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "YAxisMaximum", GetYAxisMaximum, SetYAxisMaximum, VT_I4)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "XAxisMaximum", GetXAxisMaximum, SetXAxisMaximum, VT_I4)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "Y2AxisMaximum", GetY2AxisMaximum, SetY2AxisMaximum, VT_I4)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "TitleTextColor", GetTitleTextColor, SetTitleTextColor, VT_COLOR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "TitleFont", GetTitleFont, SetTitleFont, VT_BSTR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "DataColors", GetDataColors, SetDataColors, VT_VARIANT)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "LabelFont", GetLabelFont, SetLabelFont, VT_BSTR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "GridColor", GetGridColor, SetGridColor, VT_COLOR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "LabelColor", GetLabelColor, SetLabelColor, VT_COLOR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "AxisTextColor", GetAxisTextColor, SetAxisTextColor, VT_COLOR)
DISP_PROPERTY_EX(CXChartCtrlCtrl, "Data", GetData, SetData, VT_VARIANT)
DISP_FUNCTION(CXChartCtrlCtrl, "ShowLegend", ShowLegend, VT_EMPTY, VTS_BOOL)
DISP_FUNCTION(CXChartCtrlCtrl, "EditCopy", EditCopy, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CXChartCtrlCtrl, "AddDataPoint", AddDataPoint, VT_EMPTY, VTS_I4 VTS_R8)
DISP_FUNCTION(CXChartCtrlCtrl, "RemoveSeries", RemoveSeries, VT_EMPTY, VTS_BSTR)
DISP_FUNCTION(CXChartCtrlCtrl, "EnableZoom", EnableZoom, VT_EMPTY, VTS_BOOL)
	DISP_FUNCTION(CXChartCtrlCtrl, "SetRollingGraph", SetRollingGraph, VT_EMPTY, VTS_I4)
DISP_PROPERTY_PARAM(CXChartCtrlCtrl, "SeriesStyle", GetSeriesStyle, SetSeriesStyle, VT_I4, VTS_I4)
DISP_PROPERTY_PARAM(CXChartCtrlCtrl, "LegendText", GetLegendText, SetLegendText, VT_BSTR, VTS_I2)
DISP_PROPERTY_PARAM(CXChartCtrlCtrl, "DataPoint", GetDataPoint, SetDataPoint, VT_R8, VTS_I4 VTS_I4)
DISP_PROPERTY_PARAM(CXChartCtrlCtrl, "SeriesOnSecondaryAxis", GetSeriesOnSecondaryAxis, SetSeriesOnSecondaryAxis, VT_BOOL, VTS_I2)
DISP_PROPERTY_PARAM(CXChartCtrlCtrl, "SeriesAnnotation", GetSeriesAnnotation, SetSeriesAnnotation, VT_BSTR, VTS_I2)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CXChartCtrlCtrl, COleControl)
//{{AFX_EVENT_MAP(CXChartCtrlCtrl)
// NOTE - ClassWizard will add and remove event map entries
//    DO NOT EDIT what you see in these blocks of generated code !
//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CXChartCtrlCtrl, 1)
PROPPAGEID(CXChartCtrlPropPage::guid)
END_PROPPAGEIDS(CXChartCtrlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CXChartCtrlCtrl, "XCHARTCTRL.XChartCtrlCtrl.1",
                       0xb3b2d77b, 0x6215, 0x11d4, 0x94, 0x89, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CXChartCtrlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DXChartCtrl =
    {
        0xf2333879, 0x678e, 0x11d4, { 0x94, 0x8a, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 }
    };
const IID BASED_CODE IID_DXChartCtrlEvents =
    {
        0xf233387a, 0x678e, 0x11d4, { 0x94, 0x8a, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 }
    };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwXChartCtrlOleMisc =
    OLEMISC_ACTIVATEWHENVISIBLE |
    OLEMISC_SETCLIENTSITEFIRST |
    OLEMISC_INSIDEOUT |
    OLEMISC_CANTLINKINSIDE |
    OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CXChartCtrlCtrl, IDS_XCHARTCTRL, _dwXChartCtrlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl::CXChartCtrlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CXChartCtrlCtrl

BOOL CXChartCtrlCtrl::CXChartCtrlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
    // TODO: Verify that your control follows apartment-model threading rules.
    // Refer to MFC TechNote 64 for more information.
    // If your control does not conform to the apartment-model rules, then
    // you must modify the code below, changing the 6th parameter from
    // afxRegApartmentThreading to 0.

    if (bRegister)
        return AfxOleRegisterControlClass(
                   AfxGetInstanceHandle(),
                   m_clsid,
                   m_lpszProgID,
                   IDS_XCHARTCTRL,
                   IDB_XCHARTCTRL,
                   afxRegApartmentThreading,
                   _dwXChartCtrlOleMisc,
                   _tlid,
                   _wVerMajor,
                   _wVerMinor);
    else
        return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl::CXChartCtrlCtrl - Constructor

CXChartCtrlCtrl::CXChartCtrlCtrl()
{
    InitializeIIDs(&IID_DXChartCtrl, &IID_DXChartCtrlEvents);

    // TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl::~CXChartCtrlCtrl - Destructor


CXChartCtrlCtrl::~CXChartCtrlCtrl()
{
    // TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl::OnDraw - Drawing function


void CXChartCtrlCtrl::OnDraw(
    CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    if(!m_chartDlg.GetSafeHwnd())
    {
        pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
        pdc->TextOut(0,0,"XChartCtrl.OCX");
    }
}


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl::DoPropExchange - Persistence support

void CXChartCtrlCtrl::DoPropExchange(CPropExchange* pPX)
{
    ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
    COleControl::DoPropExchange(pPX);

    // TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl::OnResetState - Reset control to default state


void CXChartCtrlCtrl::OnResetState()
{
    COleControl::OnResetState();  // Resets defaults found in DoPropExchange

    // TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl message handlers


int CXChartCtrlCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (COleControl::OnCreate(lpCreateStruct) == -1)
        return -1;

    m_chartDlg.Create(IDD_CHART_DIALOG,this);

    return 0;
}

void CXChartCtrlCtrl::OnSize(UINT nType, int cx, int cy)
{
    COleControl::OnSize(nType, cx, cy);

    if(m_chartDlg.GetSafeHwnd())
        m_chartDlg.MoveWindow(0,0,cx,cy);
}

BSTR CXChartCtrlCtrl::GetTitleText()
{
    CString strResult;
    m_chartDlg.GetTitleText(strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetTitleText(LPCTSTR lpszNewValue)
{
    m_chartDlg.SetTitleText(lpszNewValue);

    SetModifiedFlag();
}

OLE_COLOR CXChartCtrlCtrl::GetTitleBkColor()
{
    return m_chartDlg.GetTitleBkColor();

    return RGB(0,0,0);
}

void CXChartCtrlCtrl::SetTitleBkColor(OLE_COLOR nNewValue)
{
    m_chartDlg.SetTitleBkColor(nNewValue);

    SetModifiedFlag();
}

OLE_COLOR CXChartCtrlCtrl::GetPlotBkColor()
{
    return m_chartDlg.GetPlotBkColor();
}

void CXChartCtrlCtrl::SetPlotBkColor(OLE_COLOR nNewValue)
{
    m_chartDlg.SetPlotBkColor(nNewValue);

    SetModifiedFlag();
}

BSTR CXChartCtrlCtrl::GetYAxisLabel()
{
    CString strResult;
    m_chartDlg.GetAxisLabel(VtChAxisIdY,strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetYAxisLabel(LPCTSTR lpszNewValue)
{
    m_chartDlg.SetAxisLabel(VtChAxisIdY,lpszNewValue);

    SetModifiedFlag();
}

BSTR CXChartCtrlCtrl::GetXAxisLabel()
{
    CString strResult;
    m_chartDlg.GetAxisLabel(VtChAxisIdX,strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetXAxisLabel(LPCTSTR lpszNewValue)
{
    m_chartDlg.SetAxisLabel(VtChAxisIdX,lpszNewValue);

    SetModifiedFlag();
}

BSTR CXChartCtrlCtrl::GetY2AxisLabel()
{
    CString strResult;
    m_chartDlg.GetAxisLabel(VtChAxisIdY2,strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetY2AxisLabel(LPCTSTR lpszNewValue)
{
    m_chartDlg.SetAxisLabel(VtChAxisIdY2,lpszNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetYAxisMinimum()
{
    return m_chartDlg.GetAxisMinimum(VtChAxisIdY);
}

void CXChartCtrlCtrl::SetYAxisMinimum(long nNewValue)
{
    m_chartDlg.SetAxisMinimum(VtChAxisIdY,nNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetXAxisMinimum()
{
    return m_chartDlg.GetAxisMinimum(VtChAxisIdX);
}

void CXChartCtrlCtrl::SetXAxisMinimum(long nNewValue)
{
    m_chartDlg.SetAxisMinimum(VtChAxisIdX,nNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetY2AxisMinimum()
{
    return m_chartDlg.GetAxisMinimum(VtChAxisIdY2);
}

void CXChartCtrlCtrl::SetY2AxisMinimum(long nNewValue)
{
    m_chartDlg.SetAxisMinimum(VtChAxisIdY2,nNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetYAxisMaximum()
{
    return m_chartDlg.GetAxisMaximum(VtChAxisIdY);
}

void CXChartCtrlCtrl::SetYAxisMaximum(long nNewValue)
{
    m_chartDlg.SetAxisMaximum(VtChAxisIdY,nNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetXAxisMaximum()
{
    return m_chartDlg.GetAxisMaximum(VtChAxisIdX);
}

void CXChartCtrlCtrl::SetXAxisMaximum(long nNewValue)
{
    m_chartDlg.SetAxisMaximum(VtChAxisIdX,nNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetY2AxisMaximum()
{
    return m_chartDlg.GetAxisMaximum(VtChAxisIdY2);
}

void CXChartCtrlCtrl::SetY2AxisMaximum(long nNewValue)
{
    m_chartDlg.SetAxisMaximum(VtChAxisIdY2,nNewValue);

    SetModifiedFlag();
}

long CXChartCtrlCtrl::GetSeriesStyle(long lSeries)
{
    return m_chartDlg.GetSeriesStyle(lSeries);
}

void CXChartCtrlCtrl::SetSeriesStyle(long lSeries, long nNewValue)
{
    m_chartDlg.SetSeriesStyle(lSeries,(VtChSeriesType)nNewValue);

    SetModifiedFlag();
}

OLE_COLOR CXChartCtrlCtrl::GetTitleTextColor()
{
    return m_chartDlg.GetTitleTextColor();
}

void CXChartCtrlCtrl::SetTitleTextColor(OLE_COLOR nNewValue)
{
    m_chartDlg.SetTitleTextColor(nNewValue);

    SetModifiedFlag();
}

BSTR CXChartCtrlCtrl::GetTitleFont()
{
    CString strResult;
    m_chartDlg.GetTitleFont(strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetTitleFont(LPCTSTR lpszNewValue)
{
    m_chartDlg.SetTitleFont(lpszNewValue);
    SetModifiedFlag();
}

VARIANT CXChartCtrlCtrl::GetDataColors()
{
    VARIANT vaResult;
    VariantInit(&vaResult);

    m_chartDlg.GetDataColors(vaResult);

    return vaResult;
}

void CXChartCtrlCtrl::SetDataColors(const VARIANT FAR& newValue)
{
    m_chartDlg.SetDataColors(newValue);

    SetModifiedFlag();
}

BSTR CXChartCtrlCtrl::GetLabelFont()
{
    CString strResult;
    m_chartDlg.GetAxisLabelFont(strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetLabelFont(LPCTSTR lpszNewValue)
{
    m_chartDlg.SetAxisLabelFont(lpszNewValue);

    SetModifiedFlag();
}

OLE_COLOR CXChartCtrlCtrl::GetGridColor()
{
    return m_chartDlg.GetGridColor();
}

void CXChartCtrlCtrl::SetGridColor(OLE_COLOR nNewValue)
{
    m_chartDlg.SetGridColor(nNewValue);

    SetModifiedFlag();
}

OLE_COLOR CXChartCtrlCtrl::GetLabelColor()
{
    return m_chartDlg.GetAxisLabelColor();
}

void CXChartCtrlCtrl::SetLabelColor(OLE_COLOR nNewValue)
{
    m_chartDlg.SetAxisLabelColor(nNewValue);

    SetModifiedFlag();
}

OLE_COLOR CXChartCtrlCtrl::GetAxisTextColor()
{
    return m_chartDlg.GetAxisTextColor();
}

void CXChartCtrlCtrl::SetAxisTextColor(OLE_COLOR nNewValue)
{
    m_chartDlg.SetAxisTextColor(nNewValue);

    SetModifiedFlag();
}

VARIANT CXChartCtrlCtrl::GetData()
{
    VARIANT vaResult;
    VariantInit(&vaResult);

    m_chartDlg.GetChartData(vaResult);

    return vaResult;
}

void CXChartCtrlCtrl::SetData(const VARIANT FAR& newValue)
{
    m_chartDlg.SetChartData(newValue);

    SetModifiedFlag();
}

void CXChartCtrlCtrl::ShowLegend(BOOL bShow)
{
    m_chartDlg.ShowLegend(bShow);
}

BSTR CXChartCtrlCtrl::GetLegendText(short nSeries)
{
    CString strResult;
    m_chartDlg.GetLegendText(nSeries,strResult);

    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetLegendText(short nSeries, LPCTSTR lpszNewValue)
{
    m_chartDlg.SetLegendText(nSeries,lpszNewValue);

    SetModifiedFlag();
}

void CXChartCtrlCtrl::EditCopy()
{
    m_chartDlg.CopyToClipboard();
}


double CXChartCtrlCtrl::GetDataPoint(long nIndex, long nSeries)
{
    return m_chartDlg.GetDataPoint(nIndex,nSeries);
}

void CXChartCtrlCtrl::SetDataPoint(long nIndex, long nSeries, double newValue)
{
    m_chartDlg.SetDataPoint(nIndex,nSeries,newValue);

    SetModifiedFlag();
}

void CXChartCtrlCtrl::AddDataPoint(long nSeries, double dValue)
{
    m_chartDlg.AddDataPoint(nSeries,dValue);
}

BOOL CXChartCtrlCtrl::OnEraseBkgnd(CDC* pDC)
{
    return true;
    //return COleControl::OnEraseBkgnd(pDC);
}


BOOL CXChartCtrlCtrl::GetSeriesOnSecondaryAxis(short nSeries)
{
    return m_chartDlg.GetSeriesOnSecondaryAxis(nSeries);
}

void CXChartCtrlCtrl::SetSeriesOnSecondaryAxis(short nSeries, BOOL bNewValue)
{
    m_chartDlg.SetSeriesOnSecondaryAxis(nSeries,bNewValue);

    SetModifiedFlag();
}

BSTR CXChartCtrlCtrl::GetSeriesAnnotation(short nSeries)
{
    CString strResult;
    m_chartDlg.GetSeriesAnnotation(nSeries,strResult);
    return strResult.AllocSysString();
}

void CXChartCtrlCtrl::SetSeriesAnnotation(short nSeries, LPCTSTR lpszNewValue)
{
    m_chartDlg.SetSeriesAnnotation(nSeries,lpszNewValue);

    SetModifiedFlag();
}

void CXChartCtrlCtrl::RemoveSeries(LPCTSTR szSeries)
{
    m_chartDlg.RemoveSeries(szSeries);
}

void CXChartCtrlCtrl::EnableZoom(BOOL bEnable)
{
    m_chartDlg.EnableZoom(bEnable);
}

void CXChartCtrlCtrl::SetRollingGraph(long nNumPoints) 
{
	m_chartDlg.SetRollingGraph(nNumPoints);
}
