/* Copyright (C) 2000 Cyrano SA

   This file is part of OpenSTA

   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.

   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html

   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

//========================================================================
//
// TEHttpRecords.inl
// -----------------
//=========================================================================

const AtvfKey TRcrdConnect::		KEY("Connect");
const AtvfKey TRcrdRequest::		KEY("Request");
const AtvfKey TRcrdAuthentication:: KEY("BAuthentication");
const AtvfKey TRcrdDisconnect::		KEY("Disconnect");
const AtvfKey TRcrdHttpResponse::	KEY("Lload");
const AtvfKey TRcrdSynchronize::	KEY("Synchronize");


//
// tof Section: connect 
bool TRcrdConnect::_registeredCreator = false;
const bool TRcrdConnect::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdConnect::KEY] = SharedPtr<TRecCreator>(new TRecMake<TRcrdConnect>());
    _registeredCreator = true;
	return true;
}

//
// tof Section: Request 
bool TRcrdRequest::_registeredCreator = false;
const bool TRcrdRequest::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdRequest::KEY] = SharedPtr<TRecCreator>(new TRecMake<TRcrdRequest>());
    _registeredCreator = true;
	return true;
}

//
// tof Section: Authentication
bool TRcrdAuthentication::_registeredCreator = false;
const bool TRcrdAuthentication::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdAuthentication::KEY] = SharedPtr<TRecCreator>(new TRecMake<TRcrdAuthentication>());
    _registeredCreator = true;
	return true;
}

//
// tof Section: disconnect 
bool TRcrdDisconnect::_registeredCreator = false;
const bool TRcrdDisconnect::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdDisconnect::KEY] = SharedPtr<TRecCreator>(new TRecMake<TRcrdDisconnect>());
    _registeredCreator = true;
	return true;
}

//
// tof Section: HttpResponse
bool TRcrdHttpResponse::_registeredCreator = false;
const bool TRcrdHttpResponse::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdHttpResponse::KEY] = SharedPtr<TRecCreator>(new TRecMake<TRcrdHttpResponse>());
    _registeredCreator = true;
	return true;
}

//
// tof Section: Synchronize
bool TRcrdSynchronize::_registeredCreator = false;
const bool TRcrdSynchronize::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdSynchronize::KEY] = SharedPtr<TRecCreator>(new TRecMake<TRcrdSynchronize>());
    _registeredCreator = true;
	return true;
}
