// TEPrfInfo.cpp : Defines the entry point for the DLL application.

#include "windows.h"

#if !defined(PRFDATA_COLLECT_SUPPORTED)
#error PRFDATA_COLLECT_SUPPORTED must be defined for this project
#endif

#include "PerfCounters.hpp"

using namespace OpenSTA_Performance;

#include "PerfCounterMap.hpp"

CPerfClient* pPerf = NULL;


///////////// Performance DLL Required exports //////////////


extern "C" {
DWORD __declspec(dllexport) WINAPI OpenSTA_Open(PWSTR pDevNames)
{
    if(pPerf == NULL)
    {
        pPerf = new CPerfClient(L"OpenSTA_TE", L"OpenSTA_Open", L"OpenSTA_Collect", L"OpenSTA_Close");
        if(pPerf->ParseMap(OpenSTAPerf, MAP_SIZE(OpenSTAPerf)) == ERROR_SUCCESS)
        {
            if(pPerf->AdjustTitleIndexes() == ERROR_SUCCESS)
            {
                DWORD dwRet = pPerf->Initialize();
                if(dwRet == ERROR_SUCCESS || dwRet == ERROR_ALREADY_EXISTS)
                {
                }
                else
                {
                    delete pPerf;
                    pPerf = NULL;
                }
            }
        }
    }
    return ERROR_SUCCESS;
}


DWORD __declspec(dllexport) WINAPI OpenSTA_Close(void)
{
    if(pPerf)
    {
        delete pPerf;
        pPerf = NULL;
    }
    return ERROR_SUCCESS;
}


DWORD __declspec(dllexport) WINAPI OpenSTA_Collect(PWSTR pszValueName, 
   PVOID* ppData, PDWORD pcbTotalBytes, PDWORD pNumObjectTypes)
{
    DWORD dwRet = ERROR_SUCCESS;
    if(pPerf)
        dwRet = pPerf->Collect(pszValueName, ppData, pcbTotalBytes, pNumObjectTypes);
    else
    {
        *pcbTotalBytes = *pNumObjectTypes = 0;
    }

    return dwRet;
}

}


// Export these 3 functions as the interface to our Performance Data
#pragma comment(linker, "/export:OpenSTA_Open=_OpenSTA_Open@4")
#pragma comment(linker, "/export:OpenSTA_Close=_OpenSTA_Close@0")
#pragma comment(linker, "/export:OpenSTA_Collect=_OpenSTA_Collect@16")

