/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include <winsock2.h>
#include <definition.h>
#include "TEMainStructure.hpp"


CMainExecuterStructure *g_pTExecuter = NULL;

int main(int argc, char* argv[])
{
#ifdef _DEBUG
_asm { int 3 };   // ### L.M. LM TO REMOVED!!
#endif

    int iRes = 0;

    HMODULE ole32Lib = LoadLibrary("ole32.dll");    // To avoid troubles on W2K.

    CyrtoolsInitialize();
    CFastLock::Init();

    g_pTExecuter = new CMainExecuterStructure();
    if(g_pTExecuter->Init(argc, argv) == FALSE)
        iRes = 1;
    else
    {
        if(g_pTExecuter->GetCmdLineOptions().option_supplied("-i") || g_pTExecuter->GetCmdLineOptions().option_supplied("-u"))
            iRes = 0;   // Was started to install / uninstal the perf counters.
        else
            iRes = g_pTExecuter->Run();
    }

    delete g_pTExecuter;
    g_pTExecuter = NULL;

    CyrtoolsUninitialize();
    FreeLibrary(ole32Lib);

    return iRes;
}
