/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _OPENSTA_ERRORCODES_H_
#define _OPENSTA_ERRORCODES_H_


////////////////////////////////////////////////////////////////////////////////
// Error codes definition file.
//
// Return values: unless otherwise stated, a DWORD return value is a
// GetLastError() error code.
////////////////////////////////////////////////////////////////////////////////

// The error codes are based on the Win32 error code system.
// Refer to Microsoft's WinError.h for more information.

//// OpenSTA error code definitions:

#define MAKE_ERROR_CODE(severity,facility,code) (((severity)<<30)|((facility)<<16)|(code))

enum OpenSTASeverity
{
    OPENSTA_SEVERITY_SUCCESS       = 0,
    OPENSTA_SEVERITY_INFORMATIONAL = 1,
    OPENSTA_SEVERITY_WARNING       = 2,
    OPENSTA_SEVERITY_ERROR         = 3
};

enum OpenSTAFacility
{
// samples:
//  OPENSTA_FACILITY_IOCP = 1,
//  OPENSTA_FACILITY_ASYNC_TCP_SOCKET = 2
    OPENSTA_FACILITY_THREAD  = 1,
    OPENSTA_FACILITY_TIMER   = 2,
    OPENSTA_FACILITY_REQUEST = 3
};

enum OpenSTAErrorCode
{
// sample:
//  OPENSTA_E_BAD_IO = MAKE_ERROR_CODE(OPENSTA_SEVERITY_ERROR,OPENSTA_FACILITY_IOCP,1)
    OPENSTA_E_NULLCLIENT = MAKE_ERROR_CODE(OPENSTA_SEVERITY_ERROR,OPENSTA_FACILITY_THREAD,1),
    OPENSTA_E_TIMER_TIMEOUT = MAKE_ERROR_CODE(OPENSTA_SEVERITY_ERROR,OPENSTA_FACILITY_TIMER,1),
    OPENSTA_E_BAD_STATE = MAKE_ERROR_CODE(OPENSTA_SEVERITY_ERROR,OPENSTA_FACILITY_REQUEST,1),
};

#endif  // _OPENSTA_ERRORCODES_H_
