/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// CORBAInfo.h: interface for the CCORBAInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTTPINFO_H__41AEA3AD_03D2_453C_87CC_1B42E1017824__INCLUDED_)
#define AFX_HTTPINFO_H__41AEA3AD_03D2_453C_87CC_1B42E1017824__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <OSTAORB\OSTAORB.h>
#include <InjectorStatus.h>
#include <TestManager.h>

class CHTTPInfo  
{
public:
	CHTTPInfo();
	virtual ~CHTTPInfo();
	void SetManagerReg(CString strReg);
	void AddTaskId(TaskId taskID);
	void RemoveTaskId(TaskId taskID);
	void StartCollector();
	void StopCollector();
	void WriteLog();

	CString m_strManagerReg;
	int m_bActiveWindows;
	vector<TaskId> m_taskIDList;
	TaskSnap2List m_allVUSnaps;
	static UINT GetUpdate(LPVOID);

	HANDLE m_hEndThreadEvent;
	int GetRefreshRate();

private:
	CWinThread *m_pUpdateThread;
};

#endif // !defined(AFX_HTTPINFO_H__41AEA3AD_03D2_453C_87CC_1B42E1017824__INCLUDED_)
