/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CCustomizeGraphPage.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "CustomizeGraphPage.h"
#include "GraphCustomiseDlg.h"
#include "GraphWnd.h"
#include "..\Include\HttpHelpID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ISO_VIRTBAR 0
#define AREA        1
#define LINEONLY    2
#define LINE        3
#define VIRTBAR     4

/////////////////////////////////////////////////////////////////////////////
// CustomizeGraphPage property page

IMPLEMENT_DYNCREATE(CCustomizeGraphPage, CPropertyPage)

CCustomizeGraphPage::CCustomizeGraphPage(CGraphWnd *pGraphWnd) : CPropertyPage(CCustomizeGraphPage::IDD),
	m_pGraphWnd(pGraphWnd)
{
    //{{AFX_DATA_INIT(CCustomizeGraphPage)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT

    m_LabelCol.currentcolor = m_pGraphWnd->m_colLabel;
    m_BGCol.currentcolor = m_pGraphWnd->m_colPlotBk;
    m_ATCol.currentcolor = m_pGraphWnd->m_colAxisText;
    m_GridCol.currentcolor = m_pGraphWnd->m_colGrid;
    m_DefCol0.currentcolor = m_pGraphWnd->m_arDefLineColours[0];
    m_DefCol1.currentcolor = m_pGraphWnd->m_arDefLineColours[1];
    m_DefCol2.currentcolor = m_pGraphWnd->m_arDefLineColours[2];
    m_DefCol3.currentcolor = m_pGraphWnd->m_arDefLineColours[3];
    m_DefCol4.currentcolor = m_pGraphWnd->m_arDefLineColours[4];
    m_DefCol5.currentcolor = m_pGraphWnd->m_arDefLineColours[5];
    m_DefCol6.currentcolor = m_pGraphWnd->m_arDefLineColours[6];
    m_DefCol7.currentcolor = m_pGraphWnd->m_arDefLineColours[7];
    m_DefCol8.currentcolor = m_pGraphWnd->m_arDefLineColours[8];
    m_DefCol9.currentcolor = m_pGraphWnd->m_arDefLineColours[9];

}

CCustomizeGraphPage::~CCustomizeGraphPage()
{}


void CCustomizeGraphPage::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CCustomizeGraphPage)
    DDX_Control(pDX, IDC_LABEL_COL, m_LabelCol);
    DDX_Control(pDX, IDC_BG_COL, m_BGCol);
    DDX_Control(pDX, IDC_AT_COL, m_ATCol);
    DDX_Control(pDX, IDC_GRID_COL, m_GridCol);
    DDX_Control(pDX, IDC_LINE_COL0, m_DefCol0);
    DDX_Control(pDX, IDC_LINE_COL1, m_DefCol1);
    DDX_Control(pDX, IDC_LINE_COL2, m_DefCol2);
    DDX_Control(pDX, IDC_LINE_COL3, m_DefCol3);
    DDX_Control(pDX, IDC_LINE_COL4, m_DefCol4);
    DDX_Control(pDX, IDC_LINE_COL5, m_DefCol5);
    DDX_Control(pDX, IDC_LINE_COL6, m_DefCol6);
    DDX_Control(pDX, IDC_LINE_COL7, m_DefCol7);
    DDX_Control(pDX, IDC_LINE_COL8, m_DefCol8);
    DDX_Control(pDX, IDC_LINE_COL9, m_DefCol9);
    DDX_Control(pDX, IDC_LABEL_FONT, m_LabelFontCombo);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CCustomizeGraphPage, CPropertyPage)
//{{AFX_MSG_MAP(CCustomizeGraphPage)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomizeGraphPage message handlers

BOOL CCustomizeGraphPage::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    m_LabelFontCombo.Initialize();
    int sel = m_LabelFontCombo.FindStringExact(0,m_pGraphWnd->m_strLabelFont);
    m_LabelFontCombo.SetCurSel(sel);

    CComboBox* pGraphType = (CComboBox*)GetDlgItem(IDC_GRAPH_TYPE);

    CGraphCustomiseDlg* pCust = (CGraphCustomiseDlg*)GetParent();
    int nGraphStyle = pCust->GetGraphStyle();

    pGraphType->SetCurSel(nGraphStyle);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CCustomizeGraphPage::OnOK()
{
    m_pGraphWnd->m_colLabel = m_LabelCol.currentcolor;
    m_pGraphWnd->m_colPlotBk = m_BGCol.currentcolor;
    m_pGraphWnd->m_colGrid = m_GridCol.currentcolor;
    m_pGraphWnd->m_colAxisText = m_ATCol.currentcolor;
    m_pGraphWnd->m_arDefLineColours[0] = m_DefCol0.currentcolor;
    m_pGraphWnd->m_arDefLineColours[1] = m_DefCol1.currentcolor;
    m_pGraphWnd->m_arDefLineColours[2] = m_DefCol2.currentcolor;
    m_pGraphWnd->m_arDefLineColours[3] = m_DefCol3.currentcolor;
    m_pGraphWnd->m_arDefLineColours[4] = m_DefCol4.currentcolor;
    m_pGraphWnd->m_arDefLineColours[5] = m_DefCol5.currentcolor;
    m_pGraphWnd->m_arDefLineColours[6] = m_DefCol6.currentcolor;
    m_pGraphWnd->m_arDefLineColours[7] = m_DefCol7.currentcolor;
    m_pGraphWnd->m_arDefLineColours[8] = m_DefCol8.currentcolor;
    m_pGraphWnd->m_arDefLineColours[9] = m_DefCol9.currentcolor;

    int sel = m_LabelFontCombo.GetCurSel();
    if(sel != CB_ERR)
        m_LabelFontCombo.GetLBText(sel,m_pGraphWnd->m_strTitleFont);

    CComboBox* pGraphType = (CComboBox*)GetDlgItem(IDC_GRAPH_TYPE);
    CGraphCustomiseDlg* pCust = (CGraphCustomiseDlg*)GetParent();

    pCust->SetGraphStyle(pGraphType->GetCurSel());

    CPropertyPage::OnOK();
}


BOOL CCustomizeGraphPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	pHelpInfo->dwContextId = HIDD_COMMON_CUSTOMIZE_GRAPH;		
	return CPropertyPage::OnHelpInfo(pHelpInfo);
}
