/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//    CyrExecuteLocalCommand.h                                              //
//    This is the header file for the CyrExecuteLocalCommand Class.         //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
#ifndef _CYREXECUTELOCALCOMMAND_H_
#define _CYREXECUTELOCALCOMMAND_H_
#include <wtypes.h>

class CyrExecuteLocalCommand
{

    //
    //    Public Member Functions
    //
public:
    CyrExecuteLocalCommand  (CString _strCurrentDir);
    virtual ~CyrExecuteLocalCommand();

    virtual bool DidCommandSucceed      (CString& SuccessText) const;
    //
    //    Implementation funtion
    //
    int ExecuteCommand  (char *pCommandLine
                         ,CString &strOutput);

    //
    //    Private data members and functions
    //
private:
    int         InvokeImage     (char*  pImageName);

    void        ReadFromChild   () ;

    int         GoMultiThread   ( char*   pCommandLine);

    void        ErrorExit       (CString lpszMessage);

    HANDLE      m_hChildStdoutRd;
    HANDLE      m_hChildStdoutWr;
    HANDLE      m_hChildStdinRd;

    CString     m_strCurrentDir;
    //
    // Used to store the output
    CString m_strOutput;
};
#endif

