/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// HeaderView.cpp : implementation file
//

#include "stdafx.h"
#include "Modeller.h"
#include "Constantes.h"
#include "resource.h"
#include "HeaderView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//----------------------------------------------------------------------------

IMPLEMENT_DYNCREATE(CHeaderView, COSGridView)  //OS

//----------------------------------------------------------------------------

BEGIN_MESSAGE_MAP( CHeaderView, COSGridView)  //OS
//{{AFX_MSG_MAP(CHeaderView)
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//----------------------------------------------------------------------------

CHeaderView::CHeaderView() : m_bInitialized(FALSE)
{}

//----------------------------------------------------------------------------


CHeaderView::~CHeaderView()
{}

/////////////////////////////////////////////////////////////////////////////
// CHeaderView drawing
/////////////////////////////////////////////////////////////////////////////
// CHeaderView diagnostics
//----------------------------------------------------------------------------


void CHeaderView::FillGrid(CString _strData)
{
    CWaitCursor wc;

    m_wndGrid.SetLastDataRow( 0 )  ;   //OS

    int nReturnPos = _strData.Find(STR_HEADER_SEPARATOR ) ;
    CString strTemp = _strData;
    CString strHeader ;
    CString strValue ;
    //----
    //SetReadOnly(FALSE) ;     //OS

    m_wndGrid.DeleteNonFixedRows();

    while( nReturnPos >= 0 )
    {
        strHeader = strTemp.Left( nReturnPos ) ;
        strTemp = strTemp.Right( strTemp.GetLength() - nReturnPos - strlen( STR_HEADER_SEPARATOR ) ) ;
        int nPos = strHeader.Find(':') ;
        if( nPos >= 0 )
        {
            strValue = strHeader.Right( strHeader.GetLength() - nPos - 1 ) ;
            strHeader = strHeader.Left( nPos ) ;
            AddRow( strHeader , strValue ) ;
        }
        nReturnPos = strTemp.Find(STR_HEADER_SEPARATOR ) ;
    }

    if (strTemp.GetLength() != 0)
    {
        int nPos = strTemp.Find(':') ;
        if( nPos >= 0 )
        {
            strValue = strTemp.Right( strTemp.GetLength() - nPos - 1 ) ;
            strTemp= strTemp.Left( nPos ) ;
            AddRow( strTemp, strValue ) ;
        }
    }

    AdjustRowsToHeight() ;

    //SetReadOnly(TRUE) ;
}

//----------------------------------------------------------------------------


BOOL CHeaderView::AddRow( const CString& strHeader , const CString& strValue )
{
    BOOL bRet = TRUE ;
    int nIndex ;
    //----
    nIndex  = m_wndGrid.InsertRow( NULL );

    if( nIndex == -1 ) return FALSE ;

    m_wndGrid.SetLastDataRow( nIndex )  ;

    bRet = bRet && m_wndGrid.SetValueRowCol( nIndex , 0, strHeader ) ;   //OS
    bRet = bRet && m_wndGrid.SetValueRowCol( nIndex , 1, strValue ) ;    //OS

    return bRet ;
}

//----------------------------------------------------------------------------

void CHeaderView::OnInitialUpdate()   //OS
{
    if(!m_bInitialized)
    {
        COSGridView::OnInitialUpdate();

        CString strValue;
        //---
        m_wndGrid.SetColumnCount( 2 );
        m_wndGrid.SetRowCount( 1 );
        m_wndGrid.SetFixedRowCount( 1 );

        strValue.LoadString( IDS_GRID_HDR_NAME );
        m_wndGrid.SetValueRowCol( 0, 0 , strValue ) ;

        strValue.LoadString( IDS_GRID_HDR_VALUE );
        m_wndGrid.SetValueRowCol( 0, 1 , strValue ) ;

        m_bInitialized = TRUE;
    }
}
