#if !defined(AFX_URLListDlg_H__649E1724_D8B9_11D3_930B_00104B4B2995__INCLUDED_)
#define AFX_URLListDlg_H__649E1724_D8B9_11D3_930B_00104B4B2995__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// URLListDlg.h: header file
//

#include <IECache.h>
#include "resource.h"

class CURLListDlg : public CDialog
{
    DECLARE_DYNCREATE(CURLListDlg)

    //Attribute
public:
    CListCtrl               m_ListCtrl ;
    int                     m_idFile ;
    CImageList              m_imlNormal ;

    // Construction
public:
    CURLListDlg( std::list<URLKey> &URLList, URLKey &outKey, CWnd* pParent = NULL ) ;
    CURLListDlg( CWnd* pParent = NULL )
    {}
    ;
    ~CURLListDlg() ;

    // Dialog Data
    //{{AFX_DATA(CURLListDlg)
    enum { IDD = IDD_URLLIST_DLG };
    //}}AFX_DATA


    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CURLListDlg)
public:
protected:
    //}}AFX_VIRTUAL

    // Implementation
protected:

    BOOL InitList()  ;
    void FillList() ;

    virtual BOOL Verify( ) ;
    virtual void DisplayErrorMessage()  ;
    virtual void Ctrl2Values() ;

    // Generated message map functions
    //{{AFX_MSG(CURLListDlg)
    virtual BOOL    OnInitDialog();
    virtual void    OnOK();
    afx_msg HBRUSH  OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
    afx_msg void    OnDblclkListURL(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

private:

    std::list<URLKey> *     m_pURLList ;
    URLKey *                m_poutKey ;
public:
	CString					m_szUrl;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_URLListDlg_H__649E1724_D8B9_11D3_930B_00104B4B2995__INCLUDED_)
