/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// HttpStatsDlg.h : header file
//

#if !defined(AFX_HTTPSTATSDLG_H__58113167_3BC0_11D4_BDA1_00C04F89E392__INCLUDED_)
#define AFX_HTTPSTATSDLG_H__58113167_3BC0_11D4_BDA1_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CHttpStatsDlg dialog
#include "DataTypes.h"

class CHttpStatsDlg : public CDialog
{
    // Construction
public:
    CHttpStatsDlg(CWnd* pParent = NULL);    // standard constructor
    ~CHttpStatsDlg();

    BOOL LoadFile(const CString& strPath);
    void ShowFilter();

    // Dialog Data
    //{{AFX_DATA(CHttpStatsDlg)
    enum { IDD = IDD_HTTPSTATS_DIALOG };
    CListCtrl   m_ctlList;
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CHttpStatsDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual void OnCancel();
    virtual void OnOK();
    //}}AFX_VIRTUAL
    afx_msg void OnExport();

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CHttpStatsDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnGetdispinfoList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnColumnclickStatsList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnFilter();
    afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
    //}}AFX_MSG
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    DECLARE_MESSAGE_MAP()

    void ShowStatus(BOOL bShow);

    BOOL LoadHttpData();
    void SetupDefaultFilters();
    void ApplyFilters();
    BOOL IsStatInFilter(HttpData*);
    static int SortHttpData( const void *arg1, const void *arg2 );
    static UINT LoadHttpThread(LPVOID);

    CString m_strHttpPath;
    BOOL m_bLoading;
    BOOL m_bReverseSort;

    CStringArray m_arstrURLs;
    CArray <HttpData*,HttpData*> m_arHttpData;
    CArray <HttpData*,HttpData*> m_arVisibleStats;

    FilterData m_FilterData;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HTTPSTATSDLG_H__58113167_3BC0_11D4_BDA1_00C04F89E392__INCLUDED_)
