/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CCustomizeGraphPage | Property sheet for graph display customization
//
////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_CustomizeGraphPage_H__B2B050D6_3856_11D3_BE0D_00A02456D506__INCLUDED_)
#define AFX_CustomizeGraphPage_H__B2B050D6_3856_11D3_BE0D_00A02456D506__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CustomizeGraphPage.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CCustomizeGraphPage dialog

#include "FontCombo.h"
#include "TipWnd.h"
#include "ColorBtn.h"

class CGraphWnd;
// @class Property sheet for graph display customization
// @base public | CPropertyPage
class CCustomizeGraphPage : public CPropertyPage
{
    DECLARE_DYNCREATE(CCustomizeGraphPage)


    // @access Public Members
public:

	CCustomizeGraphPage(){}
    // @cmember Constructor
    CCustomizeGraphPage(CGraphWnd* pGraphWnd);

    // @cmember Destructor
    ~CCustomizeGraphPage();

    // @cmember Colour chooser for label colour
    CColorBtn m_LabelCol;

    // @cmember Colour chooser for background colour
    CColorBtn m_BGCol;

    // @cmember Colour chooser for Axis Title colour
    CColorBtn m_ATCol;

    // @cmember Colour chooser for grid line colour
    CColorBtn m_GridCol;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol0;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol1;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol2;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol3;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol4;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol5;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol6;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol7;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol8;

    // @cmember Colour chooser for data colour
    CColorBtn m_DefCol9;

    // Dialog Data
    //{{AFX_DATA(CCustomizeGraphPage)
    enum { IDD = IDD_CUSTOMIZE_GRAPH };
    CFontCombo  m_LabelFontCombo;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CCustomizeGraphPage)
public:
    virtual void OnOK();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CCustomizeGraphPage)
    virtual BOOL OnInitDialog();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()

private:
    CGraphWnd* m_pGraphWnd;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CustomizeGraphPage_H__B2B050D6_3856_11D3_BE0D_00A02456D506__INCLUDED_)
