/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// FilterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FilterDlg.h"
#include "RegFunctions.h"
#include "..\include\NTPerfHelpID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg dialog


CFilterDlg::CFilterDlg(NTPHeaderList* pHeaderList,CWnd* pParent /*=NULL*/)
	: CDialog(CFilterDlg::IDD, pParent),
	m_pHeaderList(pHeaderList)
{
	//{{AFX_DATA_INIT(CFilterDlg)
	//}}AFX_DATA_INIT
}


void CFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilterDlg)
	DDX_Control(pDX, IDC_QUERY_LIST, m_ctlQueryList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilterDlg, CDialog)
	//{{AFX_MSG_MAP(CFilterDlg)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg message handlers

void CFilterDlg::OnOK() 
{
	int nCount = m_ctlQueryList.GetCount();
	for(int nItem=0;nItem<nCount;nItem++)
		((NTPHeader*)m_ctlQueryList.GetItemData(nItem))->bInFilter = false;
	
	int nSelCount = m_ctlQueryList.GetSelCount();
	int *pSel = new int[nSelCount];
	m_ctlQueryList.GetSelItems(nSelCount,pSel);
	
	for(nItem=0;nItem<nSelCount;nItem++)
		((NTPHeader*)m_ctlQueryList.GetItemData(pSel[nItem]))->bInFilter = true;
	
	delete []pSel;
	
	CDialog::OnOK();
}

BOOL CFilterDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString strQuery,strNode;
	POSITION pos = m_pHeaderList->GetHeadPosition();
	while(pos)
	{
		NTPHeader *pHeader = m_pHeaderList->GetNext(pos);
		strQuery.Format("%s, Task Group %d",pHeader->strQuery,pHeader->dwIP);
		
		int nItem = m_ctlQueryList.AddString(strQuery);
		m_ctlQueryList.SetSel(nItem,pHeader->bInFilter);
		m_ctlQueryList.SetItemData(nItem,(DWORD)pHeader);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CFilterDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	pHelpInfo->dwContextId = HIDD_NTPERF_FILTER_DLG;			
	return CDialog::OnHelpInfo(pHelpInfo);
}
