/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// GraphCustomiseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GraphCustomiseDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphCustomiseDlg

IMPLEMENT_DYNAMIC(CGraphCustomiseDlg, CPropertySheet)

CGraphCustomiseDlg::CGraphCustomiseDlg(LPCTSTR pszCaption,CGraphWnd* pGraphWnd, CWnd* pParentWnd, UINT iSelectPage)
        :CPropertySheet(pszCaption, pParentWnd, iSelectPage),
		m_GraphPage(pGraphWnd),
		m_TitlePage(pGraphWnd)
{
    AddPage(&m_GraphPage);
    AddPage(&m_TitlePage);
    //  AddPage(&m_LegendPage);
}


CGraphCustomiseDlg::~CGraphCustomiseDlg()
{}



BEGIN_MESSAGE_MAP(CGraphCustomiseDlg, CPropertySheet)
//{{AFX_MSG_MAP(CGraphCustomiseDlg)
// NOTE - the ClassWizard will add and remove mapping macros here.
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphCustomiseDlg message handlers

BOOL CGraphCustomiseDlg::OnInitDialog()
{
    BOOL bResult = CPropertySheet::OnInitDialog();

    //Show the context sensitive help ? button
    LONG style = ::GetWindowLong(m_hWnd, GWL_EXSTYLE);
    style |= WS_EX_CONTEXTHELP;
    ::SetWindowLong(m_hWnd, GWL_EXSTYLE, style);

    return bResult;
}

void CGraphCustomiseDlg::SetGraphStyle(int nStyle)
{
    m_nStyle = (GraphStyles)nStyle;
}

int CGraphCustomiseDlg::GetGraphStyle()
{
    return m_nStyle;
}

void CGraphCustomiseDlg::SetChartStyle(int nStyle)
{
    switch(nStyle)
    {
    case VtChSeriesType2dArea:
        m_nStyle = enAreaGraph;
        break;
    case VtChSeriesType2dLine:
        m_nStyle = enLineGraph;
        break;
    case VtChSeriesType2dBar:
        m_nStyle = enVBarGraph;
        break;
    default:
        ASSERT(FALSE);
        m_nStyle = enAreaGraph;
        break;
    }
}

int CGraphCustomiseDlg::GetChartStyle()
{
    switch(m_nStyle)
    {
    case enAreaGraph:
        return VtChSeriesType2dArea;
        break;
    case enLineGraph:
        return VtChSeriesType2dLine;
        break;
    case enVBarGraph:
        return VtChSeriesType2dBar;
        break;
    default:
        ASSERT(FALSE);
        return VtChSeriesType2dArea;
        break;
    }
}
