/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     TestExecuterImpl
// @module  TestExecuterImpl|implement InjectorControl
//
///////////////////////////////////////////////////////////////////////////////
#ifndef _TestExecuterImpl_H_
#define _TestExecuterImpl_H_
#include "TestExecuter.h"
#include "InjectorControl.h"
#include <OSTAORB/OSTAORB.h>
#include <repository/CyrStRepository.h>
#include "mthread.hpp"
#include <string>
using namespace std;

class TestExecuterImpl:public virtual POA_TestExecuter,public PortableServer::RefCountServantBase
{
public:
    TestExecuterImpl(CORBAServer* corba, string strTestRunString, string strTestName, string strReposHost);
    virtual ~TestExecuterImpl();

	CORBA::Boolean StartTaskGroup(TaskGroupExecInfo& tgExec);
    CORBA::Boolean StopTaskGroup(long lTaskGroupId);
    CORBA::Boolean Stop();

    CORBA::Boolean GetStatsSnapshot(TestExecuterSnapshot& teSnapshot);
	InjectorControl_ptr m_pControl;
    std::string  m_registered_name;
	TaskGroupExecInfo m_execInf;

	bool ParseProfile(string strFilePath);

	struct QueryInfo
	{
		int nIndex;
		string strHeading;
		string strQuery;
		bool bDelta;
		int nFreq;
	};

	vector<QueryInfo> m_queries;

	void RunQuery(int index);
	bool m_bRunning;
	void Shutdown();
	long m_offset;

private:
    CORBAServer* m_corba;

	CTThread* m_pRunThread;
	long m_nStartTime;
	int m_nQueriesCompleted;
};
#endif
