// CategoryEdit.cpp : implementation file
//

#include "stdafx.h"
#include "snmpplugin.h"
#include "CategoryEdit.h"
#include "..\include\SNMPHelpID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCategoryEdit dialog


CCategoryEdit::CCategoryEdit(CWnd* pParent, int nCat)
	: CDialog(CCategoryEdit::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCategoryEdit)
	m_strWalkPoint = _T("");
	//}}AFX_DATA_INIT

	m_nSelCat = nCat;
}


void CCategoryEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCategoryEdit)
	DDX_Control(pDX, IDC_CAT_NAME, m_ctlCatName);
	DDX_Text(pDX, IDC_CAT_WALKPOINT, m_strWalkPoint);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCategoryEdit, CDialog)
	//{{AFX_MSG_MAP(CCategoryEdit)
	ON_CBN_SELCHANGE(IDC_CAT_NAME, OnSelchangeCatName)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCategoryEdit message handlers

BOOL CCategoryEdit::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ResetCategories();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCategoryEdit::OnSelchangeCatName() 
{
	m_nSelCat =  m_ctlCatName.GetCurSel();
	m_strWalkPoint = m_arrCat.GetAt(m_nSelCat).strWalkStart;
	UpdateData(FALSE);
}

void CCategoryEdit::OnApply() 
{
	UpdateData(TRUE);

	CString strCatName;
	m_ctlCatName.GetWindowText(strCatName);
	int nCatNum = -1;
	for (int i = 0; i<m_arrCat.GetSize(); i++)
	{
		if(m_arrCat.GetAt(i).strCatName == strCatName)
		{
			nCatNum = i;
			break;
		}
	}

	DWORD dwMaxBufferSize=255;

	CString strIniFile = getenv("OPENSTA_HOME");
	strIniFile += "\\BaseUI\\snmpcat.ini";

	if (nCatNum != -1)
	{
		CString strCat;
		strCat.Format("CAT%d",nCatNum+1);
		WritePrivateProfileString("CATEGORY",strCat, strCatName+","+m_strWalkPoint,strIniFile);
		CATEGORY cat = m_arrCat.GetAt(nCatNum);
		cat.strWalkStart = m_strWalkPoint;
		m_arrCat.SetAt(nCatNum, cat);
	}
	else
	{
		int nCat = GetPrivateProfileInt("CATEGORY","NUMCAT", 0,strIniFile);
		CString strNumCat;
		strNumCat.Format("%d",nCat+1);
		WritePrivateProfileString("CATEGORY","NUMCAT", strNumCat,strIniFile);
		CString strCat;
		strCat.Format("CAT%d",nCat+1);
		WritePrivateProfileString("CATEGORY",strCat, strCatName+","+m_strWalkPoint,strIniFile);

		CATEGORY cat;
		cat.strCatName = strCatName;
		cat.strWalkStart = m_strWalkPoint;
		m_arrCat.Add(cat);
		ResetCategories();
	}
}

void CCategoryEdit::ResetCategories()
{
	m_ctlCatName.ResetContent();
	ReadCategories();

	for (int i = 0; i<m_arrCat.GetSize(); i++)
	{
		m_ctlCatName.InsertString(i, m_arrCat.GetAt(i).strCatName);
	}

	m_ctlCatName.SetCurSel(0);
	OnSelchangeCatName();
}

void CCategoryEdit::ReadCategories()
{
	m_arrCat.RemoveAll();
	DWORD dwMaxBufferSize=255;

	CString strIniFile = getenv("OPENSTA_HOME");
	strIniFile += "\\BaseUI\\snmpcat.ini";

	int nCat = GetPrivateProfileInt("CATEGORY","NUMCAT", 0,strIniFile);

	for (int i = 0; i<nCat; i++)
	{
		CString strKey;
		strKey.Format("CAT%d",i+1);
		CString strCat;
		GetPrivateProfileString("CATEGORY",strKey,"",strCat.GetBuffer(dwMaxBufferSize),dwMaxBufferSize,strIniFile);
		strCat.ReleaseBuffer();

		int nLen = strCat.GetLength();
		int nPos = strCat.Find(',');
		CATEGORY cat;
		cat.strCatName = strCat.Left(nPos);
		cat.strWalkStart = strCat.Right(nLen - nPos -1);
		m_arrCat.Add(cat);
	}
}


BOOL CCategoryEdit::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	pHelpInfo->dwContextId = HIDD_SNMP_CATEGORY;	
	return CDialog::OnHelpInfo(pHelpInfo);
}
